/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, Delegate_$type, fromEnum, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox, String_$type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { XRipple } from "./XRipple";
import { NativeUI } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { ElevationMode_$type } from "igniteui-react-core";
import { ElevationHelper } from "./ElevationHelper";
import { ButtonDisplayStyle_$type } from "./ButtonDisplayStyle";
import { isNaN_ } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { ThemeResolver } from "./ThemeResolver";
import { ButtonClickEventArgs } from "./ButtonClickEventArgs";
import { MouseEventArgs } from "igniteui-react-core";
import { FocusEventArgs } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { ButtonVisualModelExport } from "./ButtonVisualModelExport";
import { AppearanceHelper } from "igniteui-react-core";
import { FontUtil } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { Theme } from "./Theme";
/**
 * @hidden
 */
var ButtonView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ButtonView, _super);
    function ButtonView() {
        var _this = _super.call(this) || this;
        _this.b = null;
        _this.k = null;
        _this.d = null;
        _this.h = new List$1(Delegate_$type, 0);
        _this.e = true;
        _this.n = null;
        _this.j = NaN;
        _this.i = NaN;
        _this.l = null;
        _this.c = null;
        _this.m = null;
        _this.p = null;
        _this.o = null;
        return _this;
    }
    ButtonView.prototype.aq = function () {
    };
    ButtonView.prototype.g = function () {
        return true;
    };
    Object.defineProperty(ButtonView.prototype, "q", {
        get: function () {
            return this.n;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ButtonView.prototype, "s", {
        get: function () {
            return this.m;
        },
        enumerable: false,
        configurable: true
    });
    ButtonView.prototype.ak = function (a) {
        var e_1, _a;
        var _this = this;
        if (a == null) {
            try {
                for (var _b = __values(fromEnum(this.h)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    b();
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            this.h.clear();
            return;
        }
        this.k = a;
        this.k.rootWrapper.setStyleProperty("display", "flex");
        this.k.rootWrapper.setStyleProperty("flex-direction", "row");
        this.k.rootWrapper.setStyleProperty("flex-wrap", "no-wrap");
        this.k.rootWrapper.setStyleProperty("align-items", "center");
        var c = this.k.createElement("button");
        this.n = c;
        this.n.setStyleProperty("position", "relative");
        this.n.setStyleProperty("display", "inline-flex");
        this.n.setStyleProperty("align-items", "center");
        this.n.setStyleProperty("justify-content", "center");
        this.a0();
        this.n.setStyleProperty("border", "none");
        this.n.setStyleProperty("cursor", "pointer");
        this.n.setStyleProperty("user-select", "none");
        this.n.setStyleProperty("outline-style", "none");
        this.n.setStyleProperty("-webkit-tap-highlight-color", "transparent");
        this.n.setStyleProperty("overflow", "hidden");
        this.n.setStyleProperty("white-space", "no-wrap");
        this.n.setStyleProperty("color", "#000");
        this.n.setStyleProperty("background", this.b.no._fill);
        NativeUI.o(this.n, this.b.kz);
        this.n.setAttribute("id", this.b.hy);
        this.ax();
        this.h.add(c.listen("change", runOn(this, this.z)));
        this.h.add(c.listen("click", runOn(this, this.aa)));
        this.h.add(c.listen("focus", runOn(this, this.ab)));
        this.h.add(c.listen("blur", runOn(this, this.y)));
        this.h.add(this.k.rootWrapper.listen("mouseenter", runOn(this, this.v)));
        this.h.add(this.k.rootWrapper.listen("mouseleave", runOn(this, this.w)));
        this.h.add(this.k.rootWrapper.listen("mousedown", runOn(this, this.u)));
        this.h.add(this.k.rootWrapper.listen("mouseup", runOn(this, this.x)));
        this.h.add(this.k.rootWrapper.listen("focusin", runOn(this, this.ac)));
        this.h.add(this.k.rootWrapper.listen("focusout", runOn(this, this.ad)));
        this.k.append(c);
        var d = this.k.createElement("div");
        var e = this.k.getSubRenderer(d);
        d.setStyleProperty("position", "absolute");
        d.setStyleProperty("width", "100%");
        d.setStyleProperty("height", "100%");
        d.setStyleProperty("left", "0px");
        d.setStyleProperty("top", "0px");
        d.setStyleProperty("overflow", "hidden");
        var f = new XRipple();
        f.provideContainer(e);
        f.q = c;
        var g = this.k.getExternal(f, this.k.rootWrapper, this.k.getExternal(this.b, null, null));
        f.h = false;
        f.k = true;
        this.c = f;
        this.n.append(d);
        var h = this.k.createElement("div");
        h.addClass("ig-button-content");
        h.setStyleProperty("font-family", "Verdana");
        h.setStyleProperty("font-weight", "400");
        h.setStyleProperty("font-size", ".875rem");
        this.m = h;
        this.h.add(h.listen("click", runOn(this, this.t)));
        this.n.append(h);
        this.o = h;
        this.k.getPortal(h, "ChildContent", function (i) {
            var comp_ = i.componentRef;
            _this.p = comp_;
            {
                _this.o.setStyleProperty("flex-direction", _this.b.g4);
                _this.o.setStyleProperty("align-items", _this.b.fb);
                var direction_ = _this.b.g4;
                var display_ = _this.b.fj != null ? _this.b.fj : _this.b.f0;
                var alignItems_ = _this.b.fb;
                comp_.display = display_;
                comp_.flexDirection = direction_;
                comp_.alignItems = alignItems_;
            }
        }, true);
        this.b.kl();
    };
    ButtonView.prototype.am = function () {
        this.c.i = this.b.as;
    };
    ButtonView.prototype.a0 = function () {
        var a = "2.25rem";
        var b = "2.25rem";
        var c = "2.25rem";
        var d = "2.25rem";
        var e = "3.5rem";
        var f = "3.5rem";
        var g = "3.5rem";
        var h = "3.5rem";
        var i = "5.5rem";
        var j = "2.25rem";
        var k = "0px";
        var l = ".9375rem";
        var m = ".5625rem 1rem";
        switch (this.b.q) {
            case 2:
                m = ".375rem .75rem";
                j = "1.875rem";
                e = "3rem";
                f = "3rem";
                g = "3rem";
                h = "3rem";
                l = ".6875rem";
                break;
            case 3:
                m = ".1875rem 1rem";
                j = "1.5rem";
                f = "2.5rem";
                e = "2.5rem";
                h = "2.5rem";
                g = "2.5rem";
                l = ".4375rem";
                break;
            case 4:
                m = "0.09375rem 0.5rem";
                j = "0.5rem";
                f = "1.5rem";
                e = "1.5rem";
                h = "1.5rem";
                g = "1.5rem";
                l = "0.21875rem";
                b = "1rem";
                a = "1rem";
                d = "1rem";
                c = "1rem";
                break;
        }
        if (!isNaN_(this.b.bm) && !isNaN_(this.b.bo) && !isNaN_(this.b.bn) && !isNaN_(this.b.bl)) {
            m = this.b.bo + "px " + this.b.bn + "px " + this.b.bl + "px " + this.b.bm + "px";
        }
        if (this.b.e == 4) {
            this.n.setStyleProperty("min-width", a);
            this.n.setStyleProperty("min-height", b);
            this.n.setStyleProperty("padding", k);
            this.n.setStyleProperty("width", c);
            this.n.setStyleProperty("height", d);
        }
        else if (this.b.e == 3) {
            this.n.setStyleProperty("min-width", e);
            this.n.setStyleProperty("min-height", f);
            this.n.setStyleProperty("padding", l);
            this.n.setStyleProperty("width", g);
            this.n.setStyleProperty("height", h);
        }
        else {
            this.n.setStyleProperty("width", "auto");
            this.n.setStyleProperty("height", "auto");
            this.n.setStyleProperty("min-width", i);
            this.n.setStyleProperty("min-height", j);
            this.n.setStyleProperty("padding", m);
        }
        this.k.rootWrapper.setStyleProperty("height", "auto");
        if (!isNaN_(this.b.bj) && this.b.bj > 0) {
            this.n.setStyleProperty("border-style", "solid");
        }
        else {
            this.n.setStyleProperty("border-style", "none");
        }
        if (!isNaN_(this.j)) {
            this.n.setStyleProperty("min-width", this.j.toString() + "px");
        }
        if (!isNaN_(this.i)) {
            this.n.setStyleProperty("min-height", this.i.toString() + "px");
        }
        if (this.b.ay) {
            this.n.setStyleProperty("width", "100%");
            this.n.setStyleProperty("height", "100%");
            this.k.rootWrapper.setStyleProperty("height", "100%");
        }
    };
    ButtonView.prototype.au = function () {
        switch (this.b.le) {
            case 1:
                this.n.setStyleProperty("justify-content", "center");
                this.o.setStyleProperty("flex-grow", "unset");
                break;
            case 3:
                this.n.setStyleProperty("justify-content", "stretch");
                this.o.setStyleProperty("flex-grow", "1");
                break;
            case 0:
                this.n.setStyleProperty("justify-content", "left");
                this.o.setStyleProperty("flex-grow", "unset");
                break;
            case 2:
                this.n.setStyleProperty("justify-content", "right");
                this.o.setStyleProperty("flex-grow", "unset");
                break;
        }
    };
    ButtonView.prototype.aw = function (a) {
        this.j = a;
    };
    ButtonView.prototype.av = function (a) {
        this.i = a;
    };
    ButtonView.prototype.as = function () {
        this.n.setAttribute("disabled", this.b.disabled ? "true" : "false");
        this.n.setProperty("disabled", this.b.disabled);
    };
    ButtonView.prototype.an = function () {
        if (this.k != null) {
            this.k.rootWrapper.setStyleProperty("display", this.b.f0);
            var comp_ = this.p;
            if (this.p != null) {
                this.o.setStyleProperty("display", this.b.f0);
                var display_ = this.b.fj != null ? this.b.f0 : this.b.fj;
                comp_.display = display_;
            }
            var ext_ = this.k.getExternal(this.b, null, null);
            if (ext_ && ext_._onDisplayChanged) {
                ext_._onDisplayChanged();
            }
            ;
        }
    };
    ButtonView.prototype.aj = function () {
        if (this.k != null) {
            var comp_ = this.p;
            if (this.p != null) {
                var display_ = this.b.fj != null ? this.b.fj : this.b.f0;
                comp_.display = display_;
            }
        }
    };
    ButtonView.prototype.ah = function () {
        if (this.k != null) {
            this.k.rootWrapper.setStyleProperty("align-items", this.b.fb);
            this.n.setStyleProperty("align-items", this.b.fb);
            var comp_ = this.p;
            if (this.p != null) {
                this.o.setStyleProperty("align-items", this.b.fb);
                var alignItems_ = this.b.fb;
                comp_.alignItems = alignItems_;
            }
            var ext_ = this.k.getExternal(this.b, null, null);
            if (ext_ && ext_._onAlignItemsChanged) {
                ext_._onAlignItemsChanged();
            }
            ;
        }
    };
    ButtonView.prototype.ao = function () {
        if (this.k != null) {
            this.k.rootWrapper.setStyleProperty("flex-direction", this.b.g4);
            this.n.setStyleProperty("flex-direction", this.b.g4);
            var ext_ = this.k.getExternal(this.b, null, null);
            var comp_ = this.p;
            if (this.p != null) {
                this.o.setStyleProperty("flex-direction", this.b.g4);
                var direction_ = this.b.g4;
                comp_.flexDirection = direction_;
            }
            if (ext_ && ext_._onFlexDirectionChanged) {
                ext_._onFlexDirectionChanged();
            }
            ;
        }
    };
    ButtonView.prototype.ap = function () {
        if (this.k != null) {
            this.k.rootWrapper.setStyleProperty("flex-grow", this.b.g6);
            this.n.setStyleProperty("flex-grow", this.b.g6);
            var ext_ = this.k.getExternal(this.b, null, null);
            if (ext_ && ext_._onFlexGrowChanged) {
                ext_._onFlexGrowChanged();
            }
            ;
        }
    };
    ButtonView.prototype.t = function (a) {
    };
    ButtonView.prototype.ax = function () {
        if (this.g()) {
            var a = this.b.hy;
            this.n.setAttribute("name", this.b.h6);
            this.n.setProperty("value", this.b.ee);
            if (this.b.az) {
                this.n.setAttribute("tabindex", this.b.d7.toString());
            }
            this.n.setProperty("disabled", this.b.disabled);
            {
            }
            this.n.setAttribute("aria-label", this.b.fd);
            this.n.setStyleProperty("cursor", !this.b.av ? "pointer" : "unset");
        }
    };
    ButtonView.prototype.ar = function () {
        if (this.g()) {
            var a = this.b.hy;
            this.n.setAttribute("id", a);
        }
    };
    ButtonView.prototype.v = function (a) {
        this.b.kh();
        if (this.b.a5) {
            a.stopPropagation();
        }
    };
    ButtonView.prototype.w = function (a) {
        this.b.ki();
        if (this.b.a5) {
            a.stopPropagation();
        }
    };
    ButtonView.prototype.u = function (a) {
        this.b.kg();
        if (this.b.a5) {
            a.stopPropagation();
        }
    };
    ButtonView.prototype.x = function (a) {
        this.b.kj();
        if (this.b.a5) {
            a.stopPropagation();
        }
    };
    ButtonView.prototype.y = function (a) {
        this.b.ka();
    };
    ButtonView.prototype.ab = function (a) {
        this.b.kd();
    };
    ButtonView.prototype.aa = function (a) {
        this.b.kb();
        if (!this.b.at) {
            a.preventDefault();
        }
        if (this.b.a5) {
            a.stopPropagation();
        }
    };
    ButtonView.prototype.ac = function (a) {
        this.b.ke();
    };
    ButtonView.prototype.ad = function (a) {
        this.b.kf(a.originalEvent.relatedTarget, a.originalEvent.target);
    };
    ButtonView.prototype.f = function () {
        return false;
    };
    ButtonView.prototype.z = function (a) {
    };
    ButtonView.prototype.ag = function () {
        if (KeyFrameAnimationFactory.h == null) {
            KeyFrameAnimationFactory.h = this.k;
        }
    };
    ButtonView.prototype.ai = function () {
        this.e = true;
        this.h.add(this.n.listen("change", runOn(this, this.z)));
        this.h.add(this.n.listen("click", runOn(this, this.aa)));
        this.h.add(this.n.listen("focus", runOn(this, this.ab)));
        this.h.add(this.n.listen("blur", runOn(this, this.y)));
        this.h.add(this.m.listen("click", runOn(this, this.t)));
        this.h.add(this.n.listen("mouseenter", runOn(this, this.v)));
        this.h.add(this.n.listen("mouseleave", runOn(this, this.w)));
        this.h.add(this.n.listen("mousedown", runOn(this, this.u)));
        this.h.add(this.n.listen("mouseup", runOn(this, this.x)));
        this.h.add(this.n.listen("focusin", runOn(this, this.ac)));
        this.h.add(this.n.listen("focusout", runOn(this, this.ad)));
    };
    ButtonView.prototype.al = function () {
        var e_2, _a;
        this.e = false;
        try {
            for (var _b = __values(fromEnum(this.h)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a();
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        this.h.clear();
    };
    ButtonView.prototype.at = function () {
        var model_ = this.b;
        if (model_.externalObject && model_.externalObject.refreshDefaults) {
            model_.externalObject.refreshDefaults();
        }
        ;
    };
    ButtonView.prototype.ay = function (a, b) {
        this.c.ax = a;
        this.c.aw = b;
    };
    ButtonView.prototype.az = function (a, b) {
        var c = ElevationHelper.e(a, this.b.n0, this.b.nx, this.b.nn, b);
        this.n.setStyleProperty("box-shadow", c);
    };
    ButtonView.prototype.a1 = function (a) {
        if (a != null) {
            this.m.setStyleProperty("font", a.fontString);
        }
    };
    ButtonView.prototype.ae = function (a) {
        this.m.append(a);
    };
    ButtonView.prototype.af = function () {
        this.m.removeChildren();
    };
    ButtonView.prototype.r = function () {
        return this.m.getChildCount() > 0 ? this.m.getChildAt(0) : null;
    };
    ButtonView.prototype.a = function () {
        var rect_ = this.k.rootWrapper.getNativeElement().getBoundingClientRect();
        var a = (rect_.top);
        var b = (rect_.left);
        var c = new Array(2);
        c[0] = a;
        c[1] = b;
        return c;
    };
    ButtonView.$t = markType(ButtonView, 'ButtonView');
    return ButtonView;
}(Base));
export { ButtonView };
/**
 * @hidden
 */
var XButton = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XButton, _super);
    function XButton() {
        var _this = _super.call(this) || this;
        _this._view = null;
        _this.ed = null;
        _this.po = XButton.k.ae(XButton.m, "UmbraShadowColor");
        _this.pc = XButton.k.ae(XButton.m, "PenumbraShadowColor");
        _this.n3 = XButton.k.ae(XButton.m, "AmbientShadowColor");
        _this.v = XButton.k.d(XButton.m, "ElevationMode");
        _this.pf = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBackgroundColor");
        _this.pg = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBorderColor");
        _this.ph = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledTextColor");
        _this.de = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledElevation");
        _this.dh = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "RestingElevation");
        _this.dg = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverElevation");
        _this.df = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusElevation");
        _this.pe = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderColor");
        _this.pm = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "RippleColor");
        _this.k6 = XButton.k.y(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "CornerRadius");
        _this.bt = XButton.k.i(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderWidth");
        _this.pd = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "BackgroundColor");
        _this.pn = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "TextColor");
        _this.pl = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverTextColor");
        _this.pk = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverBackgroundColor");
        _this.pi = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusBackgroundColor");
        _this.pj = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusTextColor");
        _this.oh = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledBackgroundColor");
        _this.oi = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledBorderColor");
        _this.oj = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledTextColor");
        _this.c2 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledElevation");
        _this.c5 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "RestingElevation");
        _this.c4 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverElevation");
        _this.c3 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusElevation");
        _this.og = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "BorderColor");
        _this.oo = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "RippleColor");
        _this.k3 = XButton.k.y(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "CornerRadius");
        _this.bq = XButton.k.i(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "BorderWidth");
        _this.of = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "BackgroundColor");
        _this.op = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "TextColor");
        _this.on = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverTextColor");
        _this.om = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverBackgroundColor");
        _this.ok = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusBackgroundColor");
        _this.ol = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusTextColor");
        _this.o3 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledBackgroundColor");
        _this.o4 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledBorderColor");
        _this.o5 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledTextColor");
        _this.da = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledElevation");
        _this.dd = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "RestingElevation");
        _this.dc = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverElevation");
        _this.db = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusElevation");
        _this.o2 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "BorderColor");
        _this.pa = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "RippleColor");
        _this.k5 = XButton.k.y(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "CornerRadius");
        _this.bs = XButton.k.i(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "BorderWidth");
        _this.o1 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "BackgroundColor");
        _this.pb = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "TextColor");
        _this.o9 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverTextColor");
        _this.o8 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverBackgroundColor");
        _this.o6 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusBackgroundColor");
        _this.o7 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusTextColor");
        _this.os = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledBackgroundColor");
        _this.ot = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledBorderColor");
        _this.ou = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledTextColor");
        _this.c6 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledElevation");
        _this.c9 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "RestingElevation");
        _this.c8 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverElevation");
        _this.c7 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusElevation");
        _this.or = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "BorderColor");
        _this.oz = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "RippleColor");
        _this.k4 = XButton.k.y(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "CornerRadius");
        _this.br = XButton.k.i(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "BorderWidth");
        _this.oq = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "BackgroundColor");
        _this.o0 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "TextColor");
        _this.oy = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverTextColor");
        _this.ox = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverBackgroundColor");
        _this.ov = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusBackgroundColor");
        _this.ow = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusTextColor");
        _this.n6 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledBackgroundColor");
        _this.n7 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledBorderColor");
        _this.n8 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledTextColor");
        _this.cy = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledElevation");
        _this.c1 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "RestingElevation");
        _this.c0 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverElevation");
        _this.cz = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusElevation");
        _this.n5 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "BorderColor");
        _this.od = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "RippleColor");
        _this.k2 = XButton.k.y(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "CornerRadius");
        _this.bp = XButton.k.i(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "BorderWidth");
        _this.n4 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "BackgroundColor");
        _this.oe = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "TextColor");
        _this.oc = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverTextColor");
        _this.ob = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverBackgroundColor");
        _this.n9 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusBackgroundColor");
        _this.oa = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusTextColor");
        _this.bg = NaN;
        _this.bf = NaN;
        _this.d = 0;
        _this.p = 0;
        _this.l = 0;
        _this.o = 1;
        _this.lh = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderColor");
        _this.ls = ThemeResolver.ag(XButton.m, XButton.k, "UmbraShadowColor");
        _this.lp = ThemeResolver.ag(XButton.m, XButton.k, "PenumbraShadowColor");
        _this.lf = ThemeResolver.ag(XButton.m, XButton.k, "AmbientShadowColor");
        _this.b4 = ThemeResolver.p(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "RestingElevation");
        _this.b2 = ThemeResolver.p(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusElevation");
        _this.b3 = ThemeResolver.p(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverElevation");
        _this.lq = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "RippleColor");
        _this.ks = ThemeResolver.aa(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "CornerRadius");
        _this.lg = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "BackgroundColor");
        _this.li = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBackgroundColor");
        _this.lj = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBorderColor");
        _this.lk = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledTextColor");
        _this.b1 = ThemeResolver.p(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledElevation");
        _this.s = ThemeResolver.f(XButton.m, XButton.k, "ElevationMode");
        _this.lr = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "TextColor");
        _this.lo = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverTextColor");
        _this.ll = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusBackgroundColor");
        _this.lm = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusTextColor");
        _this.ln = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverBackgroundColor");
        _this.a6 = ThemeResolver.k(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderWidth");
        _this.na = null;
        _this.nc = null;
        _this.nd = null;
        _this.ne = null;
        _this.co = -1;
        _this.nh = null;
        _this.nb = null;
        _this.cr = -1;
        _this.cq = -1;
        _this.cp = -1;
        _this.bi = NaN;
        _this.ky = new CornerRadius(1, NaN, NaN, NaN, NaN);
        _this.nj = null;
        _this.l8 = null;
        _this.ma = null;
        _this.mb = null;
        _this.mc = null;
        _this.ca = -1;
        _this.mf = null;
        _this.l9 = null;
        _this.cd = -1;
        _this.cc = -1;
        _this.cb = -1;
        _this.mh = null;
        _this.mi = null;
        _this.mg = null;
        _this.md = null;
        _this.me = null;
        _this.bd = NaN;
        _this.kv = new CornerRadius(1, NaN, NaN, NaN, NaN);
        _this.lt = null;
        _this.lv = null;
        _this.lw = null;
        _this.lx = null;
        _this.b5 = -1;
        _this.t = 0;
        _this.ml = null;
        _this.lu = null;
        _this.cs = -1;
        _this.cf = -1;
        _this.ce = -1;
        _this.z = null;
        _this.nm = null;
        _this.mn = null;
        _this.nl = null;
        _this.nk = null;
        _this.ni = null;
        _this.nf = null;
        _this.ng = null;
        _this.mj = null;
        _this.mk = null;
        _this.a7 = NaN;
        _this.kt = new CornerRadius(1, NaN, NaN, NaN, NaN);
        _this.mz = null;
        _this.m1 = null;
        _this.m2 = null;
        _this.m3 = null;
        _this.ck = -1;
        _this.m6 = null;
        _this.m0 = null;
        _this.cn = -1;
        _this.cm = -1;
        _this.cl = -1;
        _this.bh = NaN;
        _this.kx = new CornerRadius(1, NaN, NaN, NaN, NaN);
        _this.m8 = null;
        _this.m9 = null;
        _this.m7 = null;
        _this.m4 = null;
        _this.m5 = null;
        _this.ly = null;
        _this.l0 = null;
        _this.l1 = null;
        _this.l2 = null;
        _this.b6 = -1;
        _this.mm = null;
        _this.lz = null;
        _this.b9 = -1;
        _this.b8 = -1;
        _this.b7 = -1;
        _this.bc = NaN;
        _this.ku = new CornerRadius(1, NaN, NaN, NaN, NaN);
        _this.l6 = null;
        _this.l7 = null;
        _this.l5 = null;
        _this.l3 = null;
        _this.l4 = null;
        _this.mo = null;
        _this.mq = null;
        _this.mr = null;
        _this.ms = null;
        _this.cg = -1;
        _this.mv = null;
        _this.mp = null;
        _this.cj = -1;
        _this.ci = -1;
        _this.ch = -1;
        _this.be = NaN;
        _this.kw = new CornerRadius(1, NaN, NaN, NaN, NaN);
        _this.mx = null;
        _this.my = null;
        _this.mw = null;
        _this.mt = null;
        _this.mu = null;
        _this.em = "ig-native-button-" + XButton.d9++;
        _this.el = "ig-button-" + XButton.d8++;
        _this.ei = "inline-block";
        _this.eh = null;
        _this.ej = "inline-block";
        _this.ek = null;
        _this.ef = "center";
        _this.ea = null;
        _this.en = null;
        _this.ct = 0;
        _this.am = false;
        _this.eg = null;
        _this.al = false;
        _this.ao = false;
        _this.ap = true;
        _this.aj = false;
        _this.af = false;
        _this.ah = false;
        _this.aq = false;
        _this.an = false;
        _this.ak = false;
        _this.ai = false;
        _this.a9 = NaN;
        _this.bb = NaN;
        _this.ba = NaN;
        _this.a8 = NaN;
        _this.ld = 1;
        _this.rh = 1;
        _this.ag = true;
        _this.ar = false;
        _this.propertyChanged = null;
        _this.clicked = null;
        _this.mouseEnter = null;
        _this.mouseLeave = null;
        _this.mouseDown = null;
        _this.mouseUp = null;
        _this.gotFocus = null;
        _this.lostFocus = null;
        var a = new ButtonView();
        a.b = _this;
        _this.view = a;
        _this.view.aq();
        return _this;
    }
    Object.defineProperty(XButton.prototype, "view", {
        get: function () {
            return this._view;
        },
        set: function (a) {
            this._view = a;
        },
        enumerable: false,
        configurable: true
    });
    XButton.prototype.destroy = function () {
        this.provideContainer(null);
    };
    XButton.prototype.kk = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.km(a, b, c);
    };
    XButton.prototype.km = function (a, b, c) {
        switch (a) {
            case "CornerRadius":
            case "BorderColor":
            case "RestingElevation":
            case "HoverElevation":
            case "FocusElevation":
            case "RippleColor":
            case "BorderWidth":
            case "BackgroundColor":
            case "DisabledBackgroundColor":
            case "DisabledBorderColor":
            case "DisabledTextColor":
            case "DisabledElevation":
            case "HoverBackgroundColor":
            case "FocusTextColor":
            case "TextColor":
            case "HoverTextColor":
            case "FocusBackgroundColor":
            case "RaisedBorderColor":
            case "RaisedRestingElevation":
            case "RaisedFocusElevation":
            case "RaisedHoverElevation":
            case "RaisedRippleColor":
            case "RaisedBorderWidth":
            case "RaisedBackgroundColor":
            case "RaisedDisabledBackgroundColor":
            case "RaisedDisabledBorderColor":
            case "RaisedDisabledTextColor":
            case "RaisedDisabledElevation":
            case "RaisedHoverBackgroundColor":
            case "RaisedCornerRadius":
            case "RaisedFocusBackgroundColor":
            case "RaisedFocusTextColor":
            case "RaisedTextColor":
            case "RaisedHoverTextColor":
            case "FlatBorderColor":
            case "FlatRestingElevation":
            case "FlatFocusElevation":
            case "FlatHoverElevation":
            case "FlatRippleColor":
            case "FlatBorderWidth":
            case "FlatBackgroundColor":
            case "FlatDisabledBackgroundColor":
            case "FlatDisabledBorderColor":
            case "FlatDisabledTextColor":
            case "FlatDisabledElevation":
            case "FlatHoverBackgroundColor":
            case "FlatCornerRadius":
            case "FlatFocusBackgroundColor":
            case "FlatFocusTextColor":
            case "FlatTextColor":
            case "FlatHoverTextColor":
            case "OutlinedRippleColor":
            case "OutlinedRestingElevation":
            case "OutlinedFocusElevation":
            case "OutlinedHoverElevation":
            case "OutlinedBorderColor":
            case "OutlinedBorderWidth":
            case "OutlinedBackgroundColor":
            case "OutlinedDisabledBackgroundColor":
            case "OutlinedDisabledBorderColor":
            case "OutlinedDisabledTextColor":
            case "OutlinedDisabledElevation":
            case "OutlinedHoverBackgroundColor":
            case "OutlinedCornerRadius":
            case "OutlinedFocusBackgroundColor":
            case "OutlinedFocusTextColor":
            case "OutlinedTextColor":
            case "OutlinedHoverTextColor":
            case "FabBorderColor":
            case "FabRippleColor":
            case "FabRestingElevation":
            case "FabFocusElevation":
            case "FabHoverElevation":
            case "FabBorderWidth":
            case "FabBackgroundColor":
            case "FabDisabledBackgroundColor":
            case "FabDisabledBorderColor":
            case "FabDisabledTextColor":
            case "FabDisabledElevation":
            case "FabHoverBackgroundColor":
            case "FabCornerRadius":
            case "FabFocusBackgroundColor":
            case "FabFocusTextColor":
            case "FabTextColor":
            case "FabHoverTextColor":
            case "IconRestingElevation":
            case "IconFocusElevation":
            case "IconHoverElevation":
            case "IconBorderColor":
            case "IconRippleColor":
            case "IconBorderWidth":
            case "IconBackgroundColor":
            case "IconDisabledBackgroundColor":
            case "IconDisabledBorderColor":
            case "IconDisabledTextColor":
            case "IconDisabledElevation":
            case "IconHoverBackgroundColor":
            case "IconCornerRadius":
            case "IconFocusBackgroundColor":
            case "IconFocusTextColor":
            case "IconTextColor":
            case "IconHoverTextColor":
            case "ElevationMode":
                this.kq();
                break;
            case "BaseTheme":
                this.kr(this.n == 0 ? 2 : this.n);
                this.kq();
                break;
            case "IsDisabled":
                this.as = this.disabled || this.aw;
                this.kq();
                this.view.as();
                this.kp();
                break;
            case "DisableRipple":
                this.as = this.disabled || this.aw;
                this.kq();
                break;
            case "TextStyle":
            case "DisableHover":
                this.kp();
                break;
            case "ActualDisableRipple":
                this.view.am();
                break;
            case "ActualBackgroundColor":
            case "ActualDisabledBackgroundColor":
            case "ActualDisabledBorderColor":
            case "ActualDisabledTextColor":
            case "ActualDisabledElevation":
            case "ActualHoverBackgroundColor":
            case "ActualBorderColor":
            case "ActualFocusTextColor":
            case "ActualHoverTextColor":
            case "ActualElevationMode":
                this.kp();
                break;
            case "Density":
                this.q = this.r == 0 ? 1 : this.r;
                break;
            case "ActualDensity":
            case "ActualBorderWidth":
            case "ActualCornerRadius":
                if (this.e == 4) {
                    this.ko();
                }
                this.view.a0();
                this.kp();
                break;
            case "DisplayType":
                this.view.a0();
                this.kq();
                this.kp();
                break;
            case "ContentPaddingLeft":
            case "ContentPaddingTop":
            case "ContentPaddingRight":
            case "ContentPaddingBottom":
            case "FillAvailableSpace":
                this.view.a0();
                break;
            case "HorizontalContentAlignment":
            case "VerticalContentAlignment":
                this.view.au();
                break;
            case "InputId":
                this.view.ar();
                break;
            case "Display":
                this.view.an();
                break;
            case "ChildContentDisplay":
                this.view.aj();
                break;
            case "FlexDirection":
                this.view.ao();
                break;
            case "FlexGrow":
                this.view.ap();
                break;
            case "AlignItems":
                this.view.ah();
                break;
            case "TabIndex":
                this.view.ax();
                break;
            case "DisablePointer":
                this.view.ax();
                break;
            case "MinWidth":
                this.view.aw(this.by);
                this.view.a0();
                break;
            case "MinHeight":
                this.view.av(this.bx);
                this.view.a0();
                break;
        }
    };
    XButton.prototype.k0 = function (a, b) {
        return new CornerRadius(1, !isNaN_(a.d) ? a.d : b.d, !isNaN_(a.e) ? a.e : b.e, !isNaN_(a.c) ? a.c : b.c, !isNaN_(a.b) ? a.b : b.b);
    };
    XButton.prototype.kq = function () {
        this.u = this.w != 0 ? this.w : this.v;
        this.n0 = this.po;
        this.nx = this.pc;
        this.nn = this.n3;
        switch (this.e) {
            case 0:
                this.nq = this.pp != null ? this.pp : this.q6 != null ? this.q6 : this.pf;
                this.nr = this.pq != null ? this.pq : this.q7 != null ? this.q7 : this.pg;
                this.ns = this.pr != null ? this.pr : this.q8 != null ? this.q8 : this.ph;
                this.cu = this.di >= 0 ? this.di : this.d2 >= 0 ? this.d2 : this.de;
                this.cx = this.d6 >= 0 ? this.d6 : this.d5 >= 0 ? this.d5 : this.dh;
                this.cw = this.dt >= 0 ? this.dt : this.d4 >= 0 ? this.d4 : this.dg;
                this.cv = this.ds >= 0 ? this.ds : this.d3 >= 0 ? this.d3 : this.df;
                this.np = this.n2 != null ? this.n2 : this.q5 != null ? this.q5 : this.pe;
                this.no = this.n1 != null ? this.n1 : this.q4 != null ? this.q4 : this.pd;
                this.nv = this.qg != null ? this.qg : this.rb != null ? this.rb : this.pk;
                this.kz = this.k0(this.k1, this.k0(this.lc, this.k6));
                this.bj = !isNaN_(this.bk) ? this.bk : !isNaN_(this.b0) ? this.b0 : this.bt;
                this.ny = this.rf != null ? this.rf : this.rd != null ? this.rd : this.pm;
                this.nt = this.qe != null ? this.qe : this.q9 != null ? this.q9 : this.pi;
                this.nu = this.qf != null ? this.qf : this.ra != null ? this.ra : this.pj;
                this.nz = this.rg != null ? this.rg : this.re != null ? this.re : this.pn;
                this.nw = this.qh != null ? this.qh : this.rc != null ? this.rc : this.pl;
                break;
            case 2:
                this.nq = this.pp != null ? this.pp : this.qv != null ? this.qv : this.o3;
                this.nr = this.pq != null ? this.pq : this.qw != null ? this.qw : this.o4;
                this.ns = this.pr != null ? this.pr : this.qx != null ? this.qx : this.o5;
                this.cu = this.di >= 0 ? this.di : this.dy >= 0 ? this.dy : this.da;
                this.cx = this.d6 >= 0 ? this.d6 : this.d1 >= 0 ? this.d1 : this.dd;
                this.cw = this.dt >= 0 ? this.dt : this.d0 >= 0 ? this.d0 : this.dc;
                this.cv = this.ds >= 0 ? this.ds : this.dz >= 0 ? this.dz : this.db;
                this.np = this.n2 != null ? this.n2 : this.qu != null ? this.qu : this.o2;
                this.no = this.qg != null ? this.qg : this.n1 != null ? this.n1 : this.qt != null ? this.qt : this.o1;
                this.nv = this.q0 != null ? this.q0 : this.o8;
                this.kz = this.k0(this.k1, this.k0(this.lb, this.k5));
                this.bj = !isNaN_(this.bk) ? this.bk : !isNaN_(this.bz) ? this.bz : this.bs;
                this.ny = this.rf != null ? this.rf : this.q2 != null ? this.q2 : this.pa;
                this.nt = this.qe != null ? this.qe : this.qy != null ? this.qy : this.o6;
                this.nu = this.qf != null ? this.qf : this.qz != null ? this.qz : this.o7;
                this.nz = this.rg != null ? this.rg : this.q3 != null ? this.q3 : this.pb;
                this.nw = this.qh != null ? this.qh : this.q1 != null ? this.q1 : this.o9;
                break;
            case 1:
                this.nq = this.pp != null ? this.pp : this.p5 != null ? this.p5 : this.oh;
                this.nr = this.pq != null ? this.pq : this.p6 != null ? this.p6 : this.oi;
                this.ns = this.pr != null ? this.pr : this.p7 != null ? this.p7 : this.oj;
                this.cu = this.di >= 0 ? this.di : this.dn >= 0 ? this.dn : this.c2;
                this.cx = this.d6 >= 0 ? this.d6 : this.dr >= 0 ? this.dr : this.c5;
                this.cw = this.dt >= 0 ? this.dt : this.dq >= 0 ? this.dq : this.c4;
                this.cv = this.ds >= 0 ? this.ds : this.dp >= 0 ? this.dp : this.c3;
                this.np = this.n2 != null ? this.n2 : this.p4 != null ? this.p4 : this.og;
                this.no = this.n1 != null ? this.n1 : this.p3 != null ? this.p3 : this.of;
                this.nv = this.qg != null ? this.qg : this.qa != null ? this.qa : this.om;
                this.kz = this.k0(this.k1, this.k0(this.k8, this.k3));
                this.bj = !isNaN_(this.bk) ? this.bk : !isNaN_(this.bv) ? this.bv : this.bq;
                this.ny = this.rf != null ? this.rf : this.qc != null ? this.qc : this.oo;
                this.nt = this.qe != null ? this.qe : this.p8 != null ? this.p8 : this.ok;
                this.nu = this.qf != null ? this.qf : this.p9 != null ? this.p9 : this.ol;
                this.nz = this.rg != null ? this.rg : this.qd != null ? this.qd : this.op;
                this.nw = this.qh != null ? this.qh : this.qb != null ? this.qb : this.on;
                break;
            case 4:
                this.nq = this.pp != null ? this.pp : this.qk != null ? this.qk : this.os;
                this.nr = this.pq != null ? this.pq : this.ql != null ? this.ql : this.ot;
                this.ns = this.pr != null ? this.pr : this.qm != null ? this.qm : this.ou;
                this.cu = this.di >= 0 ? this.di : this.du >= 0 ? this.du : this.c6;
                this.cx = this.d6 >= 0 ? this.d6 : this.dx >= 0 ? this.dx : this.c9;
                this.cw = this.dt >= 0 ? this.dt : this.dw >= 0 ? this.dw : this.c8;
                this.cv = this.ds >= 0 ? this.ds : this.dv >= 0 ? this.dv : this.c7;
                this.np = this.n2 != null ? this.n2 : this.qj != null ? this.qj : this.or;
                this.no = this.n1 != null ? this.n1 : this.qi != null ? this.qi : this.oq;
                this.nv = this.qg != null ? this.qg : this.qp != null ? this.qp : this.ox;
                this.ko();
                this.bj = !isNaN_(this.bk) ? this.bk : !isNaN_(this.bw) ? this.bw : this.br;
                this.ny = this.rf != null ? this.rf : this.qr != null ? this.qr : this.oz;
                this.nt = this.qe != null ? this.qe : this.qn != null ? this.qn : this.ov;
                this.nu = this.qf != null ? this.qf : this.qo != null ? this.qo : this.ow;
                this.nz = this.rg != null ? this.rg : this.qs != null ? this.qs : this.o0;
                this.nw = this.qh != null ? this.qh : this.qq != null ? this.qq : this.oy;
                break;
            case 3:
                this.nq = this.pp != null ? this.pp : this.pu != null ? this.pu : this.n6;
                this.nr = this.pq != null ? this.pq : this.pv != null ? this.pv : this.n7;
                this.ns = this.pr != null ? this.pr : this.pw != null ? this.pw : this.n8;
                this.cu = this.di >= 0 ? this.di : this.dj >= 0 ? this.dj : this.cy;
                this.cx = this.d6 >= 0 ? this.d6 : this.dm >= 0 ? this.dm : this.c1;
                this.cw = this.dt >= 0 ? this.dt : this.dl >= 0 ? this.dl : this.c0;
                this.cv = this.ds >= 0 ? this.ds : this.dk >= 0 ? this.dk : this.cz;
                this.np = this.n2 != null ? this.n2 : this.pt != null ? this.pt : this.n5;
                this.no = this.n1 != null ? this.n1 : this.ps != null ? this.ps : this.n4;
                this.nv = this.qg != null ? this.qg : this.pz != null ? this.pz : this.ob;
                this.kz = this.k0(this.k1, this.k0(this.k7, this.k2));
                this.bj = !isNaN_(this.bk) ? this.bk : !isNaN_(this.bu) ? this.bu : this.bp;
                this.ny = this.rf != null ? this.rf : this.p1 != null ? this.p1 : this.pm;
                this.nt = this.qe != null ? this.qe : this.px != null ? this.px : this.n9;
                this.nu = this.qf != null ? this.qf : this.py != null ? this.py : this.oa;
                this.nz = this.rg != null ? this.rg : this.p2 != null ? this.p2 : this.oe;
                this.nw = this.qh != null ? this.qh : this.p0 != null ? this.p0 : this.oc;
                break;
        }
    };
    XButton.prototype.ko = function () {
        this.kz = this.k0(this.k1, this.k0(this.la, this.k9(this.k4)));
    };
    XButton.prototype.k9 = function (a) {
        switch (this.q) {
            case 1: return a;
            case 2: return a;
            case 3: return a;
            case 4: return new CornerRadius(0, 16);
        }
        return a;
    };
    XButton.prototype.kb = function () {
        if (this.disabled) {
            return;
        }
        if (this.clicked != null) {
            this.clicked(this, new ButtonClickEventArgs());
        }
    };
    XButton.prototype.kg = function () {
        if (this.disabled) {
            return;
        }
        if (this.mouseDown != null) {
            this.mouseDown(this, new MouseEventArgs());
        }
    };
    XButton.prototype.kj = function () {
        if (this.disabled) {
            return;
        }
        if (this.mouseUp != null) {
            this.mouseUp(this, new MouseEventArgs());
        }
    };
    XButton.prototype.ka = function () {
        this.focused = false;
        this.kp();
    };
    XButton.prototype.kd = function () {
        this.focused = true;
        this.kp();
    };
    XButton.prototype.ki = function () {
        this.a3 = false;
        this.kp();
        if (this.mouseLeave != null) {
            this.mouseLeave(this, new MouseEventArgs());
        }
    };
    XButton.prototype.kh = function () {
        this.a3 = true;
        this.kp();
        if (this.mouseEnter != null) {
            this.mouseEnter(this, new MouseEventArgs());
        }
    };
    XButton.prototype.ke = function () {
        if (this.gotFocus != null) {
            this.gotFocus(this, new FocusEventArgs());
        }
    };
    XButton.prototype.kf = function (a, b) {
        if (this.lostFocus != null) {
            this.lostFocus(this, ((function () {
                var $ret = new FocusEventArgs();
                $ret.b = a;
                $ret.a = b;
                return $ret;
            })()));
        }
    };
    XButton.prototype.kp = function () {
        var a = this.view.q;
        if (a == null) {
            return;
        }
        NativeUI.o(a, this.kz);
        NativeUI.n(a, this.np);
        if (!isNaN_(this.bj)) {
            NativeUI.p(a, new Thickness(0, this.bj));
        }
        if (this.disabled) {
            this.view.az(this.cu, this.u);
        }
        else if (this.focused && this.a2) {
            this.view.az(this.cv, this.u);
        }
        else {
            if (this.a3 && !this.au) {
                this.view.az(this.cw, this.u);
            }
            else {
                this.view.az(this.cx, this.u);
            }
        }
        if (this.disabled) {
            NativeUI.m(a, this.nq);
        }
        else if (this.focused && this.a2) {
            NativeUI.m(a, this.nt);
        }
        else {
            if (this.a3 && !this.au) {
                NativeUI.m(a, this.nv);
            }
            else {
                NativeUI.m(a, this.no);
            }
        }
        this.view.ay(this.ny, BrushUtil.h(0, 0, 0, 0));
        if (this.aa != null) {
            this.view.a1(this.aa);
        }
        if (this.disabled) {
            NativeUI.q(this.view.s, this.ns);
            NativeUI.r(this.view.s, this.ns);
        }
        else if (this.focused && this.a2) {
            NativeUI.q(this.view.s, this.nu);
            NativeUI.r(this.view.s, this.nu);
        }
        else {
            if (this.a3 && !this.au) {
                NativeUI.q(this.view.s, this.nw);
                NativeUI.r(this.view.s, this.nw);
            }
            else {
                NativeUI.q(this.view.s, this.nz);
                NativeUI.r(this.view.s, this.nz);
            }
        }
    };
    XButton.prototype.kr = function (a) {
        this.po = XButton.k.ae(a, "UmbraShadowColor");
        this.pc = XButton.k.ae(a, "PenumbraShadowColor");
        this.n3 = XButton.k.ae(a, "AmbientShadowColor");
        this.v = XButton.k.d(a, "ElevationMode");
        this.pf = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBackgroundColor");
        this.pg = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBorderColor");
        this.ph = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledTextColor");
        this.de = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledElevation");
        this.dh = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 0), "RestingElevation");
        this.dg = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverElevation");
        this.df = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusElevation");
        this.pe = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderColor");
        this.pm = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "RippleColor");
        this.k6 = XButton.k.y(a, enumGetBox(ButtonDisplayStyle_$type, 0), "CornerRadius");
        this.bt = XButton.k.i(a, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderWidth");
        this.pd = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "BackgroundColor");
        this.pn = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "TextColor");
        this.pl = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverTextColor");
        this.pk = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverBackgroundColor");
        this.pi = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusBackgroundColor");
        this.pj = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusTextColor");
        this.oh = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledBackgroundColor");
        this.oi = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledBorderColor");
        this.oj = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledTextColor");
        this.c2 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledElevation");
        this.c5 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 1), "RestingElevation");
        this.c4 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverElevation");
        this.c3 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusElevation");
        this.og = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "BorderColor");
        this.oo = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "RippleColor");
        this.k3 = XButton.k.y(a, enumGetBox(ButtonDisplayStyle_$type, 1), "CornerRadius");
        this.bq = XButton.k.i(a, enumGetBox(ButtonDisplayStyle_$type, 1), "BorderWidth");
        this.of = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "BackgroundColor");
        this.op = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "TextColor");
        this.on = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverTextColor");
        this.om = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverBackgroundColor");
        this.ok = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusBackgroundColor");
        this.ol = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusTextColor");
        this.o3 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledBackgroundColor");
        this.o4 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledBorderColor");
        this.o5 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledTextColor");
        this.da = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledElevation");
        this.dd = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 2), "RestingElevation");
        this.dc = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverElevation");
        this.db = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusElevation");
        this.o2 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "BorderColor");
        this.pa = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "RippleColor");
        this.k5 = XButton.k.y(a, enumGetBox(ButtonDisplayStyle_$type, 2), "CornerRadius");
        this.bs = XButton.k.i(a, enumGetBox(ButtonDisplayStyle_$type, 2), "BorderWidth");
        this.o1 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "BackgroundColor");
        this.pb = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "TextColor");
        this.o9 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverTextColor");
        this.o8 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverBackgroundColor");
        this.o6 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusBackgroundColor");
        this.o7 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusTextColor");
        this.os = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledBackgroundColor");
        this.ot = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledBorderColor");
        this.ou = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledTextColor");
        this.c6 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledElevation");
        this.c9 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 4), "RestingElevation");
        this.c8 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverElevation");
        this.c7 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusElevation");
        this.or = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "BorderColor");
        this.oz = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "RippleColor");
        this.k4 = XButton.k.y(a, enumGetBox(ButtonDisplayStyle_$type, 4), "CornerRadius");
        this.br = XButton.k.i(a, enumGetBox(ButtonDisplayStyle_$type, 4), "BorderWidth");
        this.oq = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "BackgroundColor");
        this.o0 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "TextColor");
        this.oy = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverTextColor");
        this.ox = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverBackgroundColor");
        this.ov = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusBackgroundColor");
        this.ow = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusTextColor");
        this.n6 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledBackgroundColor");
        this.n7 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledBorderColor");
        this.n8 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledTextColor");
        this.cy = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledElevation");
        this.c1 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 3), "RestingElevation");
        this.c0 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverElevation");
        this.cz = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusElevation");
        this.n5 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "BorderColor");
        this.od = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "RippleColor");
        this.k2 = XButton.k.y(a, enumGetBox(ButtonDisplayStyle_$type, 3), "CornerRadius");
        this.bp = XButton.k.i(a, enumGetBox(ButtonDisplayStyle_$type, 3), "BorderWidth");
        this.n4 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "BackgroundColor");
        this.oe = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "TextColor");
        this.oc = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverTextColor");
        this.ob = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverBackgroundColor");
        this.n9 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusBackgroundColor");
        this.oa = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusTextColor");
    };
    Object.defineProperty(XButton.prototype, "by", {
        get: function () {
            return this.bg;
        },
        set: function (a) {
            var b = this.bg;
            this.bg = a;
            if (b != this.bg) {
                this.kk("MinWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bx", {
        get: function () {
            return this.bf;
        },
        set: function (a) {
            var b = this.bf;
            this.bf = a;
            if (b != this.bf) {
                this.kk("MinHeight", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "e", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            var b = this.d;
            this.d = a;
            if (b != this.d) {
                this.kk("DisplayType", enumGetBox(ButtonDisplayStyle_$type, b), enumGetBox(ButtonDisplayStyle_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "r", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            var b = this.p;
            this.p = a;
            if (b != this.p) {
                this.kk("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "n", {
        get: function () {
            return this.l;
        },
        set: function (a) {
            var b = this.l;
            this.l = a;
            if (b != this.l) {
                this.kk("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "q", {
        get: function () {
            return this.o;
        },
        set: function (a) {
            var b = this.o;
            this.o = a;
            if (b != this.o) {
                this.kk("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "np", {
        get: function () {
            return this.lh;
        },
        set: function (a) {
            var b = this.lh;
            this.lh = a;
            if (b != this.lh) {
                this.kk("ActualBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "n0", {
        get: function () {
            return this.ls;
        },
        set: function (a) {
            var b = this.ls;
            this.ls = a;
            if (b != this.ls) {
                this.kk("ActualUmbraShadowColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "nx", {
        get: function () {
            return this.lp;
        },
        set: function (a) {
            var b = this.lp;
            this.lp = a;
            if (b != this.lp) {
                this.kk("ActualPenumbraShadowColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "nn", {
        get: function () {
            return this.lf;
        },
        set: function (a) {
            var b = this.lf;
            this.lf = a;
            if (b != this.lf) {
                this.kk("ActualAmbientShadowColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "cx", {
        get: function () {
            return this.b4;
        },
        set: function (a) {
            var b = this.b4;
            this.b4 = a;
            if (b != this.b4) {
                this.kk("ActualRestingElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "cv", {
        get: function () {
            return this.b2;
        },
        set: function (a) {
            var b = this.b2;
            this.b2 = a;
            if (b != this.b2) {
                this.kk("ActualFocusElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "cw", {
        get: function () {
            return this.b3;
        },
        set: function (a) {
            var b = this.b3;
            this.b3 = a;
            if (b != this.b3) {
                this.kk("ActualHoverElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ny", {
        get: function () {
            return this.lq;
        },
        set: function (a) {
            var b = this.lq;
            this.lq = a;
            if (b != this.lq) {
                this.kk("ActualRippleColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "kz", {
        get: function () {
            return this.ks;
        },
        set: function (a) {
            var b = this.ks;
            this.ks = a;
            if (!b.equals(this.ks)) {
                this.kk("ActualCornerRadius", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "no", {
        get: function () {
            return this.lg;
        },
        set: function (a) {
            var b = this.lg;
            this.lg = a;
            if (b != this.lg) {
                this.kk("ActualBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "nq", {
        get: function () {
            return this.li;
        },
        set: function (a) {
            var b = this.li;
            this.li = a;
            if (b != this.li) {
                this.kk("ActualDisabledBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "nr", {
        get: function () {
            return this.lj;
        },
        set: function (a) {
            var b = this.lj;
            this.lj = a;
            if (b != this.lj) {
                this.kk("ActualDisabledBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ns", {
        get: function () {
            return this.lk;
        },
        set: function (a) {
            var b = this.lk;
            this.lk = a;
            if (b != this.lk) {
                this.kk("ActualDisabledTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "cu", {
        get: function () {
            return this.b1;
        },
        set: function (a) {
            var b = this.b1;
            this.b1 = a;
            if (b != this.b1) {
                this.kk("ActualDisabledElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "u", {
        get: function () {
            return this.s;
        },
        set: function (a) {
            var b = this.s;
            this.s = a;
            if (b != this.s) {
                this.kk("ActualElevationMode", enumGetBox(ElevationMode_$type, b), enumGetBox(ElevationMode_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "nz", {
        get: function () {
            return this.lr;
        },
        set: function (a) {
            var b = this.lr;
            this.lr = a;
            if (b != this.lr) {
                this.kk("ActualTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "nw", {
        get: function () {
            return this.lo;
        },
        set: function (a) {
            var b = this.lo;
            this.lo = a;
            if (b != this.lo) {
                this.kk("ActualHoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "nt", {
        get: function () {
            return this.ll;
        },
        set: function (a) {
            var b = this.ll;
            this.ll = a;
            if (b != this.ll) {
                this.kk("ActualFocusBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "nu", {
        get: function () {
            return this.lm;
        },
        set: function (a) {
            var b = this.lm;
            this.lm = a;
            if (b != this.lm) {
                this.kk("ActualFocusTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "nv", {
        get: function () {
            return this.ln;
        },
        set: function (a) {
            var b = this.ln;
            this.ln = a;
            if (b != this.ln) {
                this.kk("ActualHoverBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bj", {
        get: function () {
            return this.a6;
        },
        set: function (a) {
            var b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.kk("ActualBorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "q4", {
        get: function () {
            return this.na;
        },
        set: function (a) {
            var b = this.na;
            this.na = a;
            if (b != this.na) {
                this.kk("RaisedBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "q6", {
        get: function () {
            return this.nc;
        },
        set: function (a) {
            var b = this.nc;
            this.nc = a;
            if (b != this.nc) {
                this.kk("RaisedDisabledBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "q7", {
        get: function () {
            return this.nd;
        },
        set: function (a) {
            var b = this.nd;
            this.nd = a;
            if (b != this.nd) {
                this.kk("RaisedDisabledBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "q8", {
        get: function () {
            return this.ne;
        },
        set: function (a) {
            var b = this.ne;
            this.ne = a;
            if (b != this.ne) {
                this.kk("RaisedDisabledTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "d2", {
        get: function () {
            return this.co;
        },
        set: function (a) {
            var b = this.co;
            this.co = a;
            if (b != this.co) {
                this.kk("RaisedDisabledElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "rb", {
        get: function () {
            return this.nh;
        },
        set: function (a) {
            var b = this.nh;
            this.nh = a;
            if (b != this.nh) {
                this.kk("RaisedHoverBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "q5", {
        get: function () {
            return this.nb;
        },
        set: function (a) {
            var b = this.nb;
            this.nb = a;
            if (b != this.nb) {
                this.kk("RaisedBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "d5", {
        get: function () {
            return this.cr;
        },
        set: function (a) {
            var b = this.cr;
            this.cr = a;
            if (b != this.cr) {
                this.kk("RaisedRestingElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "d4", {
        get: function () {
            return this.cq;
        },
        set: function (a) {
            var b = this.cq;
            this.cq = a;
            if (b != this.cq) {
                this.kk("RaisedHoverElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "d3", {
        get: function () {
            return this.cp;
        },
        set: function (a) {
            var b = this.cp;
            this.cp = a;
            if (b != this.cp) {
                this.kk("RaisedFocusElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "b0", {
        get: function () {
            return this.bi;
        },
        set: function (a) {
            var b = this.bi;
            this.bi = a;
            if (b != this.bi) {
                this.kk("RaisedBorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "lc", {
        get: function () {
            return this.ky;
        },
        set: function (a) {
            var b = this.ky;
            this.ky = a;
            {
                this.kk("RaisedCornerRadius", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "rd", {
        get: function () {
            return this.nj;
        },
        set: function (a) {
            var b = this.nj;
            this.nj = a;
            if (b != this.nj) {
                this.kk("RaisedRippleColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "p3", {
        get: function () {
            return this.l8;
        },
        set: function (a) {
            var b = this.l8;
            this.l8 = a;
            if (b != this.l8) {
                this.kk("FlatBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "p5", {
        get: function () {
            return this.ma;
        },
        set: function (a) {
            var b = this.ma;
            this.ma = a;
            if (b != this.ma) {
                this.kk("FlatDisabledBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "p6", {
        get: function () {
            return this.mb;
        },
        set: function (a) {
            var b = this.mb;
            this.mb = a;
            if (b != this.mb) {
                this.kk("FlatDisabledBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "p7", {
        get: function () {
            return this.mc;
        },
        set: function (a) {
            var b = this.mc;
            this.mc = a;
            if (b != this.mc) {
                this.kk("FlatDisabledTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dn", {
        get: function () {
            return this.ca;
        },
        set: function (a) {
            var b = this.ca;
            this.ca = a;
            if (b != this.ca) {
                this.kk("FlatDisabledElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qa", {
        get: function () {
            return this.mf;
        },
        set: function (a) {
            var b = this.mf;
            this.mf = a;
            if (b != this.mf) {
                this.kk("FlatHoverBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "p4", {
        get: function () {
            return this.l9;
        },
        set: function (a) {
            var b = this.l9;
            this.l9 = a;
            if (b != this.l9) {
                this.kk("FlatBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dr", {
        get: function () {
            return this.cd;
        },
        set: function (a) {
            var b = this.cd;
            this.cd = a;
            if (b != this.cd) {
                this.kk("FlatRestingElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dq", {
        get: function () {
            return this.cc;
        },
        set: function (a) {
            var b = this.cc;
            this.cc = a;
            if (b != this.cc) {
                this.kk("FlatHoverElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dp", {
        get: function () {
            return this.cb;
        },
        set: function (a) {
            var b = this.cb;
            this.cb = a;
            if (b != this.cb) {
                this.kk("FlatFocusElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qc", {
        get: function () {
            return this.mh;
        },
        set: function (a) {
            var b = this.mh;
            this.mh = a;
            if (b != this.mh) {
                this.kk("FlatRippleColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qd", {
        get: function () {
            return this.mi;
        },
        set: function (a) {
            var b = this.mi;
            this.mi = a;
            if (b != this.mi) {
                this.kk("FlatTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qb", {
        get: function () {
            return this.mg;
        },
        set: function (a) {
            var b = this.mg;
            this.mg = a;
            if (b != this.mg) {
                this.kk("FlatHoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "p8", {
        get: function () {
            return this.md;
        },
        set: function (a) {
            var b = this.md;
            this.md = a;
            if (b != this.md) {
                this.kk("FlatFocusBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "p9", {
        get: function () {
            return this.me;
        },
        set: function (a) {
            var b = this.me;
            this.me = a;
            if (b != this.me) {
                this.kk("FlatFocusTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bv", {
        get: function () {
            return this.bd;
        },
        set: function (a) {
            var b = this.bd;
            this.bd = a;
            if (b != this.bd) {
                this.kk("FlatBorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "k8", {
        get: function () {
            return this.kv;
        },
        set: function (a) {
            var b = this.kv;
            this.kv = a;
            {
                this.kk("FlatCornerRadius", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "n1", {
        get: function () {
            return this.lt;
        },
        set: function (a) {
            var b = this.lt;
            this.lt = a;
            if (b != this.lt) {
                this.kk("BackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pp", {
        get: function () {
            return this.lv;
        },
        set: function (a) {
            var b = this.lv;
            this.lv = a;
            if (b != this.lv) {
                this.kk("DisabledBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pq", {
        get: function () {
            return this.lw;
        },
        set: function (a) {
            var b = this.lw;
            this.lw = a;
            if (b != this.lw) {
                this.kk("DisabledBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pr", {
        get: function () {
            return this.lx;
        },
        set: function (a) {
            var b = this.lx;
            this.lx = a;
            if (b != this.lx) {
                this.kk("DisabledTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "di", {
        get: function () {
            return this.b5;
        },
        set: function (a) {
            var b = this.b5;
            this.b5 = a;
            if (b != this.b5) {
                this.kk("DisabledElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "w", {
        get: function () {
            return this.t;
        },
        set: function (a) {
            var b = this.t;
            this.t = a;
            if (b != this.t) {
                this.kk("ElevationMode", enumGetBox(ElevationMode_$type, b), enumGetBox(ElevationMode_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qg", {
        get: function () {
            return this.ml;
        },
        set: function (a) {
            var b = this.ml;
            this.ml = a;
            if (b != this.ml) {
                this.kk("HoverBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "n2", {
        get: function () {
            return this.lu;
        },
        set: function (a) {
            var b = this.lu;
            this.lu = a;
            if (b != this.lu) {
                this.kk("BorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "d6", {
        get: function () {
            return this.cs;
        },
        set: function (a) {
            var b = this.cs;
            this.cs = a;
            if (b != this.cs) {
                this.kk("RestingElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dt", {
        get: function () {
            return this.cf;
        },
        set: function (a) {
            var b = this.cf;
            this.cf = a;
            if (b != this.cf) {
                this.kk("HoverElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ds", {
        get: function () {
            return this.ce;
        },
        set: function (a) {
            var b = this.ce;
            this.ce = a;
            if (b != this.ce) {
                this.kk("FocusElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "aa", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            var b = this.z;
            this.z = a;
            if (b != this.z) {
                this.kk("TextStyle", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "rg", {
        get: function () {
            return this.nm;
        },
        set: function (a) {
            var b = this.nm;
            this.nm = a;
            if (b != this.nm) {
                this.kk("TextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qh", {
        get: function () {
            return this.mn;
        },
        set: function (a) {
            var b = this.mn;
            this.mn = a;
            if (b != this.mn) {
                this.kk("HoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "rf", {
        get: function () {
            return this.nl;
        },
        set: function (a) {
            var b = this.nl;
            this.nl = a;
            if (b != this.nl) {
                this.kk("RippleColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "re", {
        get: function () {
            return this.nk;
        },
        set: function (a) {
            var b = this.nk;
            this.nk = a;
            if (b != this.nk) {
                this.kk("RaisedTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "rc", {
        get: function () {
            return this.ni;
        },
        set: function (a) {
            var b = this.ni;
            this.ni = a;
            if (b != this.ni) {
                this.kk("RaisedHoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "q9", {
        get: function () {
            return this.nf;
        },
        set: function (a) {
            var b = this.nf;
            this.nf = a;
            if (b != this.nf) {
                this.kk("RaisedFocusBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ra", {
        get: function () {
            return this.ng;
        },
        set: function (a) {
            var b = this.ng;
            this.ng = a;
            if (b != this.ng) {
                this.kk("RaisedFocusTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qe", {
        get: function () {
            return this.mj;
        },
        set: function (a) {
            var b = this.mj;
            this.mj = a;
            if (b != this.mj) {
                this.kk("FocusBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qf", {
        get: function () {
            return this.mk;
        },
        set: function (a) {
            var b = this.mk;
            this.mk = a;
            if (b != this.mk) {
                this.kk("FocusTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bk", {
        get: function () {
            return this.a7;
        },
        set: function (a) {
            var b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.kk("BorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "k1", {
        get: function () {
            return this.kt;
        },
        set: function (a) {
            var b = this.kt;
            this.kt = a;
            {
                this.kk("CornerRadius", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qt", {
        get: function () {
            return this.mz;
        },
        set: function (a) {
            var b = this.mz;
            this.mz = a;
            if (b != this.mz) {
                this.kk("OutlinedBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qv", {
        get: function () {
            return this.m1;
        },
        set: function (a) {
            var b = this.m1;
            this.m1 = a;
            if (b != this.m1) {
                this.kk("OutlinedDisabledBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qw", {
        get: function () {
            return this.m2;
        },
        set: function (a) {
            var b = this.m2;
            this.m2 = a;
            if (b != this.m2) {
                this.kk("OutlinedDisabledBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qx", {
        get: function () {
            return this.m3;
        },
        set: function (a) {
            var b = this.m3;
            this.m3 = a;
            if (b != this.m3) {
                this.kk("OutlinedDisabledTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dy", {
        get: function () {
            return this.ck;
        },
        set: function (a) {
            var b = this.ck;
            this.ck = a;
            if (b != this.ck) {
                this.kk("OutlinedDisabledElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "q0", {
        get: function () {
            return this.m6;
        },
        set: function (a) {
            var b = this.m6;
            this.m6 = a;
            if (b != this.m6) {
                this.kk("OutlinedHoverBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qu", {
        get: function () {
            return this.m0;
        },
        set: function (a) {
            var b = this.m0;
            this.m0 = a;
            if (b != this.m0) {
                this.kk("OutlinedBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "d1", {
        get: function () {
            return this.cn;
        },
        set: function (a) {
            var b = this.cn;
            this.cn = a;
            if (b != this.cn) {
                this.kk("OutlinedRestingElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "d0", {
        get: function () {
            return this.cm;
        },
        set: function (a) {
            var b = this.cm;
            this.cm = a;
            if (b != this.cm) {
                this.kk("OutlinedHoverElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dz", {
        get: function () {
            return this.cl;
        },
        set: function (a) {
            var b = this.cl;
            this.cl = a;
            if (b != this.cl) {
                this.kk("OutlinedFocusElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bz", {
        get: function () {
            return this.bh;
        },
        set: function (a) {
            var b = this.bh;
            this.bh = a;
            if (b != this.bh) {
                this.kk("OutlinedBorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "lb", {
        get: function () {
            return this.kx;
        },
        set: function (a) {
            var b = this.kx;
            this.kx = a;
            {
                this.kk("OutlinedCornerRadius", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "q2", {
        get: function () {
            return this.m8;
        },
        set: function (a) {
            var b = this.m8;
            this.m8 = a;
            if (b != this.m8) {
                this.kk("OutlinedRippleColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "q3", {
        get: function () {
            return this.m9;
        },
        set: function (a) {
            var b = this.m9;
            this.m9 = a;
            if (b != this.m9) {
                this.kk("OutlinedTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "q1", {
        get: function () {
            return this.m7;
        },
        set: function (a) {
            var b = this.m7;
            this.m7 = a;
            if (b != this.m7) {
                this.kk("OutlinedHoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qy", {
        get: function () {
            return this.m4;
        },
        set: function (a) {
            var b = this.m4;
            this.m4 = a;
            if (b != this.m4) {
                this.kk("OutlinedFocusBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qz", {
        get: function () {
            return this.m5;
        },
        set: function (a) {
            var b = this.m5;
            this.m5 = a;
            if (b != this.m5) {
                this.kk("OutlinedFocusTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ps", {
        get: function () {
            return this.ly;
        },
        set: function (a) {
            var b = this.ly;
            this.ly = a;
            if (b != this.ly) {
                this.kk("FabBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pu", {
        get: function () {
            return this.l0;
        },
        set: function (a) {
            var b = this.l0;
            this.l0 = a;
            if (b != this.l0) {
                this.kk("FabDisabledBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pv", {
        get: function () {
            return this.l1;
        },
        set: function (a) {
            var b = this.l1;
            this.l1 = a;
            if (b != this.l1) {
                this.kk("FabDisabledBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pw", {
        get: function () {
            return this.l2;
        },
        set: function (a) {
            var b = this.l2;
            this.l2 = a;
            if (b != this.l2) {
                this.kk("FabDisabledTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dj", {
        get: function () {
            return this.b6;
        },
        set: function (a) {
            var b = this.b6;
            this.b6 = a;
            if (b != this.b6) {
                this.kk("FabDisabledElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pz", {
        get: function () {
            return this.mm;
        },
        set: function (a) {
            var b = this.mm;
            this.mm = a;
            if (b != this.mm) {
                this.kk("FabHoverBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "pt", {
        get: function () {
            return this.lz;
        },
        set: function (a) {
            var b = this.lz;
            this.lz = a;
            if (b != this.lz) {
                this.kk("FabBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dm", {
        get: function () {
            return this.b9;
        },
        set: function (a) {
            var b = this.b9;
            this.b9 = a;
            if (b != this.b9) {
                this.kk("FabRestingElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dl", {
        get: function () {
            return this.b8;
        },
        set: function (a) {
            var b = this.b8;
            this.b8 = a;
            if (b != this.b8) {
                this.kk("FabHoverElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dk", {
        get: function () {
            return this.b7;
        },
        set: function (a) {
            var b = this.b7;
            this.b7 = a;
            if (b != this.b7) {
                this.kk("FabFocusElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bu", {
        get: function () {
            return this.bc;
        },
        set: function (a) {
            var b = this.bc;
            this.bc = a;
            if (b != this.bc) {
                this.kk("FabBorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "k7", {
        get: function () {
            return this.ku;
        },
        set: function (a) {
            var b = this.ku;
            this.ku = a;
            {
                this.kk("FabCornerRadius", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "p1", {
        get: function () {
            return this.l6;
        },
        set: function (a) {
            var b = this.l6;
            this.l6 = a;
            if (b != this.l6) {
                this.kk("FabRippleColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "p2", {
        get: function () {
            return this.l7;
        },
        set: function (a) {
            var b = this.l7;
            this.l7 = a;
            if (b != this.l7) {
                this.kk("FabTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "p0", {
        get: function () {
            return this.l5;
        },
        set: function (a) {
            var b = this.l5;
            this.l5 = a;
            if (b != this.l5) {
                this.kk("FabHoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "px", {
        get: function () {
            return this.l3;
        },
        set: function (a) {
            var b = this.l3;
            this.l3 = a;
            if (b != this.l3) {
                this.kk("FabFocusBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "py", {
        get: function () {
            return this.l4;
        },
        set: function (a) {
            var b = this.l4;
            this.l4 = a;
            if (b != this.l4) {
                this.kk("FabFocusTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qi", {
        get: function () {
            return this.mo;
        },
        set: function (a) {
            var b = this.mo;
            this.mo = a;
            if (b != this.mo) {
                this.kk("IconBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qk", {
        get: function () {
            return this.mq;
        },
        set: function (a) {
            var b = this.mq;
            this.mq = a;
            if (b != this.mq) {
                this.kk("IconDisabledBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ql", {
        get: function () {
            return this.mr;
        },
        set: function (a) {
            var b = this.mr;
            this.mr = a;
            if (b != this.mr) {
                this.kk("IconDisabledBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qm", {
        get: function () {
            return this.ms;
        },
        set: function (a) {
            var b = this.ms;
            this.ms = a;
            if (b != this.ms) {
                this.kk("IconDisabledTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "du", {
        get: function () {
            return this.cg;
        },
        set: function (a) {
            var b = this.cg;
            this.cg = a;
            if (b != this.cg) {
                this.kk("IconDisabledElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qp", {
        get: function () {
            return this.mv;
        },
        set: function (a) {
            var b = this.mv;
            this.mv = a;
            if (b != this.mv) {
                this.kk("IconHoverBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qj", {
        get: function () {
            return this.mp;
        },
        set: function (a) {
            var b = this.mp;
            this.mp = a;
            if (b != this.mp) {
                this.kk("IconBorderColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dx", {
        get: function () {
            return this.cj;
        },
        set: function (a) {
            var b = this.cj;
            this.cj = a;
            if (b != this.cj) {
                this.kk("IconRestingElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dw", {
        get: function () {
            return this.ci;
        },
        set: function (a) {
            var b = this.ci;
            this.ci = a;
            if (b != this.ci) {
                this.kk("IconHoverElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "dv", {
        get: function () {
            return this.ch;
        },
        set: function (a) {
            var b = this.ch;
            this.ch = a;
            if (b != this.ch) {
                this.kk("IconFocusElevation", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bw", {
        get: function () {
            return this.be;
        },
        set: function (a) {
            var b = this.be;
            this.be = a;
            if (b != this.be) {
                this.kk("IconBorderWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "la", {
        get: function () {
            return this.kw;
        },
        set: function (a) {
            var b = this.kw;
            this.kw = a;
            {
                this.kk("IconCornerRadius", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qr", {
        get: function () {
            return this.mx;
        },
        set: function (a) {
            var b = this.mx;
            this.mx = a;
            if (b != this.mx) {
                this.kk("IconRippleColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qs", {
        get: function () {
            return this.my;
        },
        set: function (a) {
            var b = this.my;
            this.my = a;
            if (b != this.my) {
                this.kk("IconTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qq", {
        get: function () {
            return this.mw;
        },
        set: function (a) {
            var b = this.mw;
            this.mw = a;
            if (b != this.mw) {
                this.kk("IconHoverTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qn", {
        get: function () {
            return this.mt;
        },
        set: function (a) {
            var b = this.mt;
            this.mt = a;
            if (b != this.mt) {
                this.kk("IconFocusBackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "qo", {
        get: function () {
            return this.mu;
        },
        set: function (a) {
            var b = this.mu;
            this.mu = a;
            if (b != this.mu) {
                this.kk("IconFocusTextColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "hy", {
        get: function () {
            return this.em;
        },
        set: function (a) {
            var b = this.em;
            this.em = a;
            if (b != this.em) {
                this.kk("InputId", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "hw", {
        get: function () {
            return this.el;
        },
        set: function (a) {
            var b = this.el;
            this.el = a;
            if (b != this.el) {
                this.kk("Id", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "f0", {
        get: function () {
            return this.ei;
        },
        set: function (a) {
            var b = this.ei;
            this.ei = a;
            if (b != this.ei) {
                this.kk("Display", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "fj", {
        get: function () {
            return this.eh;
        },
        set: function (a) {
            var b = this.eh;
            this.eh = a;
            if (b != this.eh) {
                this.kk("ChildContentDisplay", b, this.eh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "g4", {
        get: function () {
            return this.ej;
        },
        set: function (a) {
            var b = this.ej;
            this.ej = a;
            if (b != this.ej) {
                this.kk("FlexDirection", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "g6", {
        get: function () {
            return this.ek;
        },
        set: function (a) {
            var b = this.ek;
            this.ek = a;
            if (b != this.ek) {
                this.kk("FlexGrow", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "fb", {
        get: function () {
            return this.ef;
        },
        set: function (a) {
            var b = this.ef;
            this.ef = a;
            if (b != this.ef) {
                this.kk("AlignItems", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ee", {
        get: function () {
            return this.ea;
        },
        set: function (a) {
            var b = this.ea;
            this.ea = a;
            if (b != this.ea) {
                this.kk("Value", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "h6", {
        get: function () {
            return this.en;
        },
        set: function (a) {
            var b = this.en;
            this.en = a;
            if (b != this.en) {
                this.kk("Name", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "az", {
        get: function () {
            return this.am;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "d7", {
        get: function () {
            return this.ct;
        },
        set: function (a) {
            var b = this.ct;
            this.ct = a;
            this.am = true;
            if (b != this.ct) {
                this.kk("TabIndex", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "fd", {
        get: function () {
            return this.eg;
        },
        set: function (a) {
            var b = this.eg;
            this.eg = a;
            if (b != this.eg) {
                this.kk("AriaLabel", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ay", {
        get: function () {
            return this.al;
        },
        set: function (a) {
            var b = this.al;
            this.al = a;
            if (b != this.al) {
                this.kk("FillAvailableSpace", b, this.al);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "focused", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            var b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.kk("IsFocused", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "a2", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.kk("IsFocusStyleEnabled", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "aw", {
        get: function () {
            return this.aj;
        },
        set: function (a) {
            var b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.kk("DisableRipple", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "as", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.af;
            this.af = a;
            if (b != this.af) {
                this.kk("ActualDisableRipple", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "au", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.kk("DisableHover", b, this.ah);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "a3", {
        get: function () {
            return this.aq;
        },
        set: function (a) {
            var b = this.aq;
            this.aq = a;
            if (b != this.aq) {
                this.kk("IsHover", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "disabled", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.an;
            this.an = a;
            if (b != this.an) {
                this.kk("IsDisabled", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ax", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.kk("DisableTransitions", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "av", {
        get: function () {
            return this.ai;
        },
        set: function (a) {
            var b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.kk("DisablePointer", b, this.ai);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bm", {
        get: function () {
            return this.a9;
        },
        set: function (a) {
            var b = this.a9;
            this.a9 = a;
            if (b != this.a9) {
                this.kk("ContentPaddingLeft", b, this.a9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bo", {
        get: function () {
            return this.bb;
        },
        set: function (a) {
            var b = this.bb;
            this.bb = a;
            if (b != this.bb) {
                this.kk("ContentPaddingTop", b, this.bb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bn", {
        get: function () {
            return this.ba;
        },
        set: function (a) {
            var b = this.ba;
            this.ba = a;
            if (b != this.ba) {
                this.kk("ContentPaddingRight", b, this.ba);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "bl", {
        get: function () {
            return this.a8;
        },
        set: function (a) {
            var b = this.a8;
            this.a8 = a;
            if (b != this.a8) {
                this.kk("ContentPaddingBottom", b, this.a8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "le", {
        get: function () {
            return this.ld;
        },
        set: function (a) {
            var b = this.ld;
            this.ld = a;
            if (b != this.ld) {
                this.kk("HorizontalContentAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.ld));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "ri", {
        get: function () {
            return this.rh;
        },
        set: function (a) {
            var b = this.rh;
            this.rh = a;
            if (b != this.rh) {
                this.kk("VerticalContentAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.rh));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "at", {
        get: function () {
            return this.ag;
        },
        set: function (a) {
            var b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.kk("ClickTunneling", b, this.ag);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "a5", {
        get: function () {
            return this.ar;
        },
        set: function (a) {
            var b = this.ar;
            this.ar = a;
            if (b != this.ar) {
                this.kk("StopPropagation", b, this.ar);
            }
        },
        enumerable: false,
        configurable: true
    });
    XButton.prototype.kl = function () {
        this.j8();
        this.view.ay(this.ny, BrushUtil.h(0, 0, 0, 0));
        this.kp();
    };
    Object.defineProperty(XButton.prototype, "a", {
        get: function () {
            var a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 0;
            return a;
        },
        enumerable: false,
        configurable: true
    });
    XButton.prototype.j8 = function () {
        this.view.ag();
    };
    XButton.prototype.onDetachedFromUI = function () {
        this.view.al();
    };
    XButton.prototype.onAttachedToUI = function () {
        this.view.ai();
    };
    XButton.prototype.appendButtonContent = function (a) {
        this.view.ae(a);
    };
    XButton.prototype.clearButtonContent = function () {
        this.view.af();
    };
    XButton.prototype.getButtonContent = function () {
        return this.view.r();
    };
    XButton.prototype.a4 = function () {
        return this.view.g();
    };
    XButton.prototype.eb = function () {
        return this.b();
    };
    XButton.prototype.f4 = function () {
        var a = this.b();
        return a.serialize();
    };
    XButton.prototype.b = function () {
        var a = this.view.q;
        var b = this.view.s;
        var c = new ButtonVisualModelExport();
        var d = this.view.a();
        c.s = d[0];
        c.q = d[1];
        c.p = NativeUI.d(a);
        c.t = NativeUI.k(a);
        c.h = this.n;
        c.i = this.q;
        c.c = AppearanceHelper.a(NativeUI.ak(a));
        c.g = AppearanceHelper.a(this.n0);
        c.d = AppearanceHelper.a(this.nx);
        c.a = AppearanceHelper.a(this.nn);
        c.u = this.cx;
        c.e = AppearanceHelper.a(this.ny);
        c.ag = this.kz;
        c.b = AppearanceHelper.a(NativeUI.aj(a));
        c.j = this.u;
        c.f = AppearanceHelper.a(NativeUI.al(b));
        c.o = this.bj;
        c.x = this.f0;
        c.y = this.g4;
        c.z = this.g6;
        c.w = this.fb;
        c.v = this.view.s.getNativeElement().innerText;
        c.aa = this.h6;
        c.m = this.focused;
        c.k = this.as;
        c.n = this.a3;
        c.l = this.disabled;
        if (this.aa != null) {
            var e = this.aa;
            if (this.view != null && e.q == null) {
                var f = this.view.k;
                var g = FontUtil.getFontInfoFromString(f, e.fontString);
                e.q = g.q;
                e.f = g.f;
                e.r = g.r;
                e.t = g.t;
                e.u = g.u;
                e.v = g.v;
            }
            if (e.q != null) {
                c.ab = e.q;
            }
            if (!isNaN_(e.f)) {
                c.r = e.f;
            }
            if (e.v != null) {
                c.af = e.v;
            }
            if (e.t != null) {
                c.ad = e.t;
            }
            if (e.r != null) {
                c.ac = e.t;
            }
        }
        return c;
    };
    XButton.prototype.provideContainer = function (a) {
        this.view.ak(a);
    };
    XButton.$t = markType(XButton, 'XButton', Base.$, [INotifyPropertyChanged_$type]);
    XButton.m = 2;
    XButton.d9 = 0;
    XButton.d8 = 0;
    XButton.i = new Theme(1, ((function () {
        var $ret = new Dictionary$2(String_$type, Base.$, 0);
        $ret.addItem("UmbraShadowColor", BrushUtil.h(66, 0, 0, 0));
        $ret.addItem("PenumbraShadowColor", BrushUtil.h(30, 0, 0, 0));
        $ret.addItem("AmbientShadowColor", BrushUtil.h(20, 0, 0, 0));
        $ret.addItem("ElevationMode", enumGetBox(ElevationMode_$type, 1));
        return $ret;
    })()), ((function () {
        var $ret = new Dictionary$2(Base.$, Theme.$, 0);
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 0), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 2);
            $ret.addItem("HoverElevation", 4);
            $ret.addItem("FocusElevation", 8);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 4));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("TextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 220, 83, 145));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 220, 83, 145));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 1), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 0);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 4));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(13, 228, 28, 119));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(30, 228, 28, 119));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 228, 28, 119));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 2), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(30, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 0);
            $ret.addItem("BorderColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("RippleColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 4));
            $ret.addItem("BorderWidth", 1);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(13, 228, 28, 119));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(30, 228, 28, 119));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 228, 28, 119));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 4), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 0);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(30, 0, 0, 0));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 3), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 6);
            $ret.addItem("HoverElevation", 12);
            $ret.addItem("FocusElevation", 12);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("TextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 220, 83, 145));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 220, 83, 145));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 0, 0, 0));
            return $ret;
        })())));
        return $ret;
    })()));
    XButton.h = new Theme(1, ((function () {
        var $ret = new Dictionary$2(String_$type, Base.$, 0);
        $ret.addItem("UmbraShadowColor", BrushUtil.h(100, 33, 150, 243));
        $ret.addItem("PenumbraShadowColor", BrushUtil.h(70, 33, 150, 243));
        $ret.addItem("AmbientShadowColor", BrushUtil.h(40, 33, 150, 243));
        $ret.addItem("ElevationMode", enumGetBox(ElevationMode_$type, 2));
        return $ret;
    })()), ((function () {
        var $ret = new Dictionary$2(Base.$, Theme.$, 0);
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 0), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("TextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 27, 135, 220));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 21, 112, 184));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 1), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(100, 33, 150, 243));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(26, 33, 150, 243));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 33, 150, 243));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 2), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(30, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("RippleColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", 1);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(26, 33, 150, 243));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 4), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", null);
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(30, 0, 0, 0));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 33, 150, 243));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 3), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("TextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 27, 135, 220));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 21, 112, 184));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        return $ret;
    })()));
    XButton.j = new Theme(1, ((function () {
        var $ret = new Dictionary$2(String_$type, Base.$, 0);
        $ret.addItem("UmbraShadowColor", BrushUtil.h(100, 33, 150, 243));
        $ret.addItem("PenumbraShadowColor", BrushUtil.h(70, 33, 150, 243));
        $ret.addItem("AmbientShadowColor", BrushUtil.h(40, 33, 150, 243));
        $ret.addItem("ElevationMode", enumGetBox(ElevationMode_$type, 2));
        return $ret;
    })()), ((function () {
        var $ret = new Dictionary$2(Base.$, Theme.$, 0);
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 0), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("TextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 27, 135, 220));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 21, 112, 184));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 1), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(100, 33, 150, 243));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(26, 33, 150, 243));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 33, 150, 243));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 2), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(30, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("RippleColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", 1);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(26, 33, 150, 243));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 4), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", null);
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(51, 178, 191, 220));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(51, 178, 191, 220));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 3), new Theme(0, ((function () {
            var $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("TextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 27, 135, 220));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 21, 112, 184));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        return $ret;
    })()));
    XButton.k = new ThemeResolver(1, ((function () {
        var $ret = new Dictionary$2(BaseControlTheme_$type, Theme.$, 0);
        $ret.addItem(2, XButton.i);
        $ret.addItem(1, XButton.h);
        $ret.addItem(3, XButton.j);
        return $ret;
    })()), 2);
    return XButton;
}(Base));
export { XButton };
