import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { DayOfWeek } from "./DayOfWeek";
import { DayInfo } from "./DayInfo";
import { XButton } from "./XButton";
import { XIcon } from "./XIcon";
import { ControlDisplayDensity } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { FirstWeek } from "./FirstWeek";
import { SelectedValueChangedEventArgs } from "./SelectedValueChangedEventArgs";
import { CalendarVisualModelExport } from "./CalendarVisualModelExport";
/**
 * @hidden
 */
export declare class CalendarView extends Base {
    static $t: Type;
    private n;
    private o;
    private t;
    private q;
    private u;
    private s;
    private r;
    private g;
    private f;
    private h;
    private j;
    private i;
    private e;
    private p;
    private x;
    private w;
    constructor();
    c: XCalendar;
    k(): List$1<DomWrapper>;
    l(): List$1<DomWrapper>;
    ap(): void;
    m: DomRenderer;
    ao(a: DomRenderer): void;
    y(): string;
    private ab;
    private ae;
    private a5;
    a9(): void;
    private ac;
    private ad;
    bd(): void;
    private af;
    a8(): void;
    private a3;
    bc(): void;
    private aw;
    a4(): void;
    private a1;
    private a2;
    private ag;
    at(a: any, b: XButton): void;
    a0(a: string): void;
    ax(a: any, b: XIcon): void;
    az(): void;
    au(a?: boolean, b?: boolean): void;
    ay(): void;
    a7(): void;
    a6(a: number, b?: boolean): void;
    as(a?: boolean): void;
    av(a?: boolean): void;
    d(a: DomWrapper): boolean;
    ai(): void;
    private ar;
    private am;
    private ba;
    private bb;
    private z;
    private aa;
    private v;
    private aq;
    private al;
    private ak;
    private bi;
    private ah;
    private aj;
    private be;
    private bh;
    private bg;
    private bf;
    a(): number[];
    b(a: DomWrapper): number[];
    an(): void;
}
/**
 * @hidden
 */
export declare class XCalendar extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private h;
    private static readonly bk;
    private static readonly bl;
    aq: Date;
    private am;
    private ai;
    private aj;
    private ah;
    private ak;
    private al;
    private g;
    private ap;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    constructor();
    close: (sender: any) => void;
    cs(): void;
    selectedValueChanged: (sender: any, args: SelectedValueChangedEventArgs) => void;
    cu(a: Date): void;
    co(a: string, b: string, c: string): void;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    private w;
    private get x();
    private as;
    get value(): Date;
    set value(a: Date);
    private ar;
    get av(): Date;
    set av(a: Date);
    private ao;
    get au(): Date;
    set au(a: Date);
    private an;
    get at(): Date;
    set at(a: Date);
    private s;
    get t(): ControlDisplayDensity;
    set t(a: ControlDisplayDensity);
    private q;
    get r(): BaseControlTheme;
    set r(a: BaseControlTheme);
    private c6;
    get dg(): Brush;
    set dg(a: Brush);
    private dc;
    get dm(): Brush;
    set dm(a: Brush);
    private de;
    get dp(): Brush;
    set dp(a: Brush);
    private c9;
    get dj(): Brush;
    set dj(a: Brush);
    private db;
    get dl(): Brush;
    set dl(a: Brush);
    private df;
    get dq(): Brush;
    set dq(a: Brush);
    private dd;
    get dn(): Brush;
    set dn(a: Brush);
    private da;
    get dk(): Brush;
    set dk(a: Brush);
    private c8;
    get di(): Brush;
    set di(a: Brush);
    private c7;
    get dh(): Brush;
    set dh(a: Brush);
    private y;
    get ae(): boolean;
    set ae(a: boolean);
    private u;
    get v(): FontInfo;
    set v(a: FontInfo);
    private k;
    get l(): DayOfWeek;
    set l(a: DayOfWeek);
    private n;
    get o(): FirstWeek;
    set o(a: FirstWeek);
    private z;
    get af(): boolean;
    set af(a: boolean);
    protected ct(a: string, b: any, c: any): void;
    protected cv(a: string, b: any, c: any): void;
    private c3;
    private c4;
    cq(): void;
    private c1;
    private c0;
    ch(): void;
    private cx;
    private c5;
    cf(): void;
    ci(a: any, b: any, c: number): void;
    cm(a: any, b: any): void;
    private c2;
    cl(a: any, b: any): void;
    e(a: number, b: number): string[];
    cn(a: any, b: any, c: number): void;
    private cg;
    ag(): List$1<number>;
    private a9;
    private static readonly b;
    private static readonly c;
    private ba;
    private a8;
    private bb;
    private bc;
    private a7;
    private m;
    private a6;
    private bd;
    private static ac;
    ck(a: any, b: any, c: any, d: string): void;
    cj(a: any, b: any, c: string): void;
    a(): boolean[];
    bx(): string;
    by(): string;
    d(a: DayOfWeek): string[];
    j(a: number): DayInfo;
    ad(a: number): boolean;
    aa(a: number, b: number): boolean;
    ab(a: number, b: number): boolean;
    cc(a: number): void;
    cd(a: number): void;
    ce(a: number): void;
    cz(a: number, b: number): void;
    cy(): void;
    bj(): any;
    bs(): string;
    f(): CalendarVisualModelExport;
}
