import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { Tuple$2 } from "igniteui-react-core";
import { SVGNode } from "igniteui-react-core";
import { FastIterationDictionary$2 } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { PrimitiveVisualData } from "igniteui-react-core";
import { DataTemplate } from "igniteui-react-core";
import { IconViewType } from "./IconViewType";
import { IIcon } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { BrushCollection } from "igniteui-react-core";
import { IconClickedEventArgs } from "./IconClickedEventArgs";
import { IconVisualModelExport } from "./IconVisualModelExport";
/**
 * @hidden
 */
export declare class IconView extends Base {
    static $t: Type;
    constructor();
    d: XIcon;
    am(): void;
    l(): boolean;
    v: DomRenderer;
    private g;
    private o;
    get z(): any;
    get aa(): any;
    get c(): any[];
    get m(): boolean;
    q: List$1<Tuple$2<SVGNode, any>>;
    r: List$1<Tuple$2<SVGNode, any>>;
    s: List$1<Tuple$2<SVGNode, any>>;
    t: List$1<Tuple$2<SVGNode, any>>;
    u: List$1<Tuple$2<SVGNode, any>>;
    e: FastIterationDictionary$2<string, List$1<Tuple$2<SVGNode, any>>>;
    f: FastIterationDictionary$2<string, List$1<Tuple$2<SVGNode, any>>>;
    ak(a: DomRenderer): void;
    ax(a: string): void;
    ay(a: string[]): void;
    aw(a: string): void;
    private ab;
    as(a: string): void;
    av(a: any): void;
    ah(): void;
    private k;
    au(): void;
    a0(): void;
    private n;
    ao(a: Brush, b: string): void;
    ap(a: any, b: Brush): void;
    aq(a: any, b: Brush): void;
    private ac;
    an(): void;
    private ad;
    private ae;
    private j;
    private y;
    private x;
    private w;
    private p;
    ai(): void;
    al(): void;
    az(a: FontInfo): void;
    b(): number[];
    private aj;
    a(): PrimitiveVisualData[];
    private ag;
    private h;
    private at;
    private i;
    ar(a: DataTemplate, b: any): void;
    af(): void;
}
/**
 * @hidden
 */
export declare class XIcon extends Base implements INotifyPropertyChanged, IIcon {
    static $t: Type;
    constructor();
    private _view;
    get view(): IconView;
    set view(a: IconView);
    destroy(): void;
    protected cl(a: string, b: any, c: any): void;
    protected co(a: string, b: any, c: any): void;
    private cs;
    protected get t(): boolean;
    private cr;
    private cf;
    private cq;
    private cn;
    k: IconViewType;
    private j;
    static db: Brush;
    static dg: Brush;
    static df: Brush;
    static dc: Brush;
    static dd: Brush;
    static de: Brush;
    static ak: number;
    static aj: number;
    private l;
    get m(): BaseControlTheme;
    set m(a: BaseControlTheme);
    private cv;
    get c8(): Brush;
    set c8(a: Brush);
    private cw;
    get c9(): Brush;
    set c9(a: Brush);
    private cx;
    get da(): Brush;
    set da(a: Brush);
    private y;
    get ai(): number;
    set ai(a: number);
    private cy;
    get fill(): Brush;
    set fill(a: Brush);
    private c6;
    get dp(): Brush;
    set dp(a: Brush);
    private ac;
    get ao(): number;
    set ao(a: number);
    private c7;
    get dq(): Brush;
    set dq(a: Brush);
    private cz;
    get dh(): Brush;
    set dh(a: Brush);
    private c0;
    get di(): Brush;
    set di(a: Brush);
    private aa;
    get am(): number;
    set am(a: number);
    private c1;
    get dj(): Brush;
    set dj(a: Brush);
    private c;
    get e(): BrushCollection;
    set e(a: BrushCollection);
    private d;
    get f(): BrushCollection;
    set f(a: BrushCollection);
    private c2;
    get dk(): Brush;
    set dk(a: Brush);
    private c3;
    get dl(): Brush;
    set dl(a: Brush);
    private c4;
    get dm(): Brush;
    set dm(a: Brush);
    private c5;
    get dn(): Brush;
    set dn(a: Brush);
    private ay;
    get a1(): any;
    set a1(a: any);
    private a3;
    get bg(): string;
    set bg(a: string);
    private a6;
    get svgPath(): string;
    set svgPath(a: string);
    private a5;
    get svg(): string;
    set svg(a: string);
    private a;
    get b(): string[];
    set b(a: string[]);
    private ct;
    get cu(): DataTemplate;
    set cu(a: DataTemplate);
    private ax;
    get az(): any;
    set az(a: any);
    cj(): void;
    ck(): void;
    private n;
    get o(): FontInfo;
    set o(a: FontInfo);
    private static aw;
    private a4;
    get bq(): string;
    set bq(a: string);
    private au;
    private p;
    get s(): boolean;
    get av(): number;
    set av(a: number);
    private a2;
    get bb(): string;
    set bb(a: string);
    private r;
    get v(): boolean;
    set v(a: boolean);
    private q;
    get disabled(): boolean;
    set disabled(a: boolean);
    private ab;
    get an(): number;
    set an(a: number);
    private ae;
    get aq(): number;
    set aq(a: number);
    private af;
    get ar(): number;
    set ar(a: number);
    private ag;
    get as(): number;
    set as(a: number);
    private ad;
    get ap(): number;
    set ap(a: number);
    private ah;
    get at(): number;
    set at(a: number);
    private z;
    get al(): number;
    set al(a: number);
    cm(): void;
    clicked: (sender: any, args: IconClickedEventArgs) => void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    x(): boolean;
    protected w(): boolean;
    a0(): any;
    bi(): string;
    g(): IconVisualModelExport;
    provideContainer(a: DomRenderer): void;
}
