/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, Delegate_$type, fromEnum, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox, String_$type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { XRipple } from "./XRipple";
import { NativeUI } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { ElevationMode_$type } from "igniteui-react-core";
import { ElevationHelper } from "./ElevationHelper";
import { ButtonDisplayStyle_$type } from "./ButtonDisplayStyle";
import { isNaN_ } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { ThemeResolver } from "./ThemeResolver";
import { ButtonClickEventArgs } from "./ButtonClickEventArgs";
import { MouseEventArgs } from "igniteui-react-core";
import { FocusEventArgs } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { ButtonVisualModelExport } from "./ButtonVisualModelExport";
import { AppearanceHelper } from "igniteui-react-core";
import { FontUtil } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { Theme } from "./Theme";
/**
 * @hidden
 */
export let ButtonView = /*@__PURE__*/ (() => {
    class ButtonView extends Base {
        constructor() {
            super();
            this.b = null;
            this.k = null;
            this.d = null;
            this.h = new List$1(Delegate_$type, 0);
            this.e = true;
            this.n = null;
            this.j = NaN;
            this.i = NaN;
            this.l = null;
            this.c = null;
            this.m = null;
            this.p = null;
            this.o = null;
        }
        aq() {
        }
        g() {
            return true;
        }
        get q() {
            return this.n;
        }
        get s() {
            return this.m;
        }
        ak(a) {
            if (a == null) {
                for (let b of fromEnum(this.h)) {
                    b();
                }
                this.h.clear();
                return;
            }
            this.k = a;
            this.k.rootWrapper.setStyleProperty("display", "flex");
            this.k.rootWrapper.setStyleProperty("flex-direction", "row");
            this.k.rootWrapper.setStyleProperty("flex-wrap", "no-wrap");
            this.k.rootWrapper.setStyleProperty("align-items", "center");
            let c = this.k.createElement("button");
            this.n = c;
            this.n.setStyleProperty("position", "relative");
            this.n.setStyleProperty("display", "inline-flex");
            this.n.setStyleProperty("align-items", "center");
            this.n.setStyleProperty("justify-content", "center");
            this.a0();
            this.n.setStyleProperty("border", "none");
            this.n.setStyleProperty("cursor", "pointer");
            this.n.setStyleProperty("user-select", "none");
            this.n.setStyleProperty("outline-style", "none");
            this.n.setStyleProperty("-webkit-tap-highlight-color", "transparent");
            this.n.setStyleProperty("overflow", "hidden");
            this.n.setStyleProperty("white-space", "no-wrap");
            this.n.setStyleProperty("color", "#000");
            this.n.setStyleProperty("background", this.b.no._fill);
            NativeUI.o(this.n, this.b.kz);
            this.n.setAttribute("id", this.b.hy);
            this.ax();
            this.h.add(c.listen("change", runOn(this, this.z)));
            this.h.add(c.listen("click", runOn(this, this.aa)));
            this.h.add(c.listen("focus", runOn(this, this.ab)));
            this.h.add(c.listen("blur", runOn(this, this.y)));
            this.h.add(this.k.rootWrapper.listen("mouseenter", runOn(this, this.v)));
            this.h.add(this.k.rootWrapper.listen("mouseleave", runOn(this, this.w)));
            this.h.add(this.k.rootWrapper.listen("mousedown", runOn(this, this.u)));
            this.h.add(this.k.rootWrapper.listen("mouseup", runOn(this, this.x)));
            this.h.add(this.k.rootWrapper.listen("focusin", runOn(this, this.ac)));
            this.h.add(this.k.rootWrapper.listen("focusout", runOn(this, this.ad)));
            this.k.append(c);
            let d = this.k.createElement("div");
            let e = this.k.getSubRenderer(d);
            d.setStyleProperty("position", "absolute");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            d.setStyleProperty("left", "0px");
            d.setStyleProperty("top", "0px");
            d.setStyleProperty("overflow", "hidden");
            let f = new XRipple();
            f.provideContainer(e);
            f.q = c;
            let g = this.k.getExternal(f, this.k.rootWrapper, this.k.getExternal(this.b, null, null));
            f.h = false;
            f.k = true;
            this.c = f;
            this.n.append(d);
            let h = this.k.createElement("div");
            h.addClass("ig-button-content");
            h.setStyleProperty("font-family", "Verdana");
            h.setStyleProperty("font-weight", "400");
            h.setStyleProperty("font-size", ".875rem");
            this.m = h;
            this.h.add(h.listen("click", runOn(this, this.t)));
            this.n.append(h);
            this.o = h;
            this.k.getPortal(h, "ChildContent", (i) => {
                let comp_ = i.componentRef;
                this.p = comp_;
                {
                    this.o.setStyleProperty("flex-direction", this.b.g4);
                    this.o.setStyleProperty("align-items", this.b.fb);
                    let direction_ = this.b.g4;
                    let display_ = this.b.fj != null ? this.b.fj : this.b.f0;
                    let alignItems_ = this.b.fb;
                    comp_.display = display_;
                    comp_.flexDirection = direction_;
                    comp_.alignItems = alignItems_;
                }
            }, true);
            this.b.kl();
        }
        am() {
            this.c.i = this.b.as;
        }
        a0() {
            let a = "2.25rem";
            let b = "2.25rem";
            let c = "2.25rem";
            let d = "2.25rem";
            let e = "3.5rem";
            let f = "3.5rem";
            let g = "3.5rem";
            let h = "3.5rem";
            let i = "5.5rem";
            let j = "2.25rem";
            let k = "0px";
            let l = ".9375rem";
            let m = ".5625rem 1rem";
            switch (this.b.q) {
                case 2:
                    m = ".375rem .75rem";
                    j = "1.875rem";
                    e = "3rem";
                    f = "3rem";
                    g = "3rem";
                    h = "3rem";
                    l = ".6875rem";
                    break;
                case 3:
                    m = ".1875rem 1rem";
                    j = "1.5rem";
                    f = "2.5rem";
                    e = "2.5rem";
                    h = "2.5rem";
                    g = "2.5rem";
                    l = ".4375rem";
                    break;
                case 4:
                    m = "0.09375rem 0.5rem";
                    j = "0.5rem";
                    f = "1.5rem";
                    e = "1.5rem";
                    h = "1.5rem";
                    g = "1.5rem";
                    l = "0.21875rem";
                    b = "1rem";
                    a = "1rem";
                    d = "1rem";
                    c = "1rem";
                    break;
            }
            if (!isNaN_(this.b.bm) && !isNaN_(this.b.bo) && !isNaN_(this.b.bn) && !isNaN_(this.b.bl)) {
                m = this.b.bo + "px " + this.b.bn + "px " + this.b.bl + "px " + this.b.bm + "px";
            }
            if (this.b.e == 4) {
                this.n.setStyleProperty("min-width", a);
                this.n.setStyleProperty("min-height", b);
                this.n.setStyleProperty("padding", k);
                this.n.setStyleProperty("width", c);
                this.n.setStyleProperty("height", d);
            }
            else if (this.b.e == 3) {
                this.n.setStyleProperty("min-width", e);
                this.n.setStyleProperty("min-height", f);
                this.n.setStyleProperty("padding", l);
                this.n.setStyleProperty("width", g);
                this.n.setStyleProperty("height", h);
            }
            else {
                this.n.setStyleProperty("width", "auto");
                this.n.setStyleProperty("height", "auto");
                this.n.setStyleProperty("min-width", i);
                this.n.setStyleProperty("min-height", j);
                this.n.setStyleProperty("padding", m);
            }
            this.k.rootWrapper.setStyleProperty("height", "auto");
            if (!isNaN_(this.b.bj) && this.b.bj > 0) {
                this.n.setStyleProperty("border-style", "solid");
            }
            else {
                this.n.setStyleProperty("border-style", "none");
            }
            if (!isNaN_(this.j)) {
                this.n.setStyleProperty("min-width", this.j.toString() + "px");
            }
            if (!isNaN_(this.i)) {
                this.n.setStyleProperty("min-height", this.i.toString() + "px");
            }
            if (this.b.ay) {
                this.n.setStyleProperty("width", "100%");
                this.n.setStyleProperty("height", "100%");
                this.k.rootWrapper.setStyleProperty("height", "100%");
            }
        }
        au() {
            switch (this.b.le) {
                case 1:
                    this.n.setStyleProperty("justify-content", "center");
                    this.o.setStyleProperty("flex-grow", "unset");
                    break;
                case 3:
                    this.n.setStyleProperty("justify-content", "stretch");
                    this.o.setStyleProperty("flex-grow", "1");
                    break;
                case 0:
                    this.n.setStyleProperty("justify-content", "left");
                    this.o.setStyleProperty("flex-grow", "unset");
                    break;
                case 2:
                    this.n.setStyleProperty("justify-content", "right");
                    this.o.setStyleProperty("flex-grow", "unset");
                    break;
            }
        }
        aw(a) {
            this.j = a;
        }
        av(a) {
            this.i = a;
        }
        as() {
            this.n.setAttribute("disabled", this.b.disabled ? "true" : "false");
            this.n.setProperty("disabled", this.b.disabled);
        }
        an() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("display", this.b.f0);
                let comp_ = this.p;
                if (this.p != null) {
                    this.o.setStyleProperty("display", this.b.f0);
                    let display_ = this.b.fj != null ? this.b.f0 : this.b.fj;
                    comp_.display = display_;
                }
                let ext_ = this.k.getExternal(this.b, null, null);
                if (ext_ && ext_._onDisplayChanged) {
                    ext_._onDisplayChanged();
                }
                ;
            }
        }
        aj() {
            if (this.k != null) {
                let comp_ = this.p;
                if (this.p != null) {
                    let display_ = this.b.fj != null ? this.b.fj : this.b.f0;
                    comp_.display = display_;
                }
            }
        }
        ah() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("align-items", this.b.fb);
                this.n.setStyleProperty("align-items", this.b.fb);
                let comp_ = this.p;
                if (this.p != null) {
                    this.o.setStyleProperty("align-items", this.b.fb);
                    let alignItems_ = this.b.fb;
                    comp_.alignItems = alignItems_;
                }
                let ext_ = this.k.getExternal(this.b, null, null);
                if (ext_ && ext_._onAlignItemsChanged) {
                    ext_._onAlignItemsChanged();
                }
                ;
            }
        }
        ao() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("flex-direction", this.b.g4);
                this.n.setStyleProperty("flex-direction", this.b.g4);
                let ext_ = this.k.getExternal(this.b, null, null);
                let comp_ = this.p;
                if (this.p != null) {
                    this.o.setStyleProperty("flex-direction", this.b.g4);
                    let direction_ = this.b.g4;
                    comp_.flexDirection = direction_;
                }
                if (ext_ && ext_._onFlexDirectionChanged) {
                    ext_._onFlexDirectionChanged();
                }
                ;
            }
        }
        ap() {
            if (this.k != null) {
                this.k.rootWrapper.setStyleProperty("flex-grow", this.b.g6);
                this.n.setStyleProperty("flex-grow", this.b.g6);
                let ext_ = this.k.getExternal(this.b, null, null);
                if (ext_ && ext_._onFlexGrowChanged) {
                    ext_._onFlexGrowChanged();
                }
                ;
            }
        }
        t(a) {
        }
        ax() {
            if (this.g()) {
                let a = this.b.hy;
                this.n.setAttribute("name", this.b.h6);
                this.n.setProperty("value", this.b.ee);
                if (this.b.az) {
                    this.n.setAttribute("tabindex", this.b.d7.toString());
                }
                this.n.setProperty("disabled", this.b.disabled);
                {
                }
                this.n.setAttribute("aria-label", this.b.fd);
                this.n.setStyleProperty("cursor", !this.b.av ? "pointer" : "unset");
            }
        }
        ar() {
            if (this.g()) {
                let a = this.b.hy;
                this.n.setAttribute("id", a);
            }
        }
        v(a) {
            this.b.kh();
            if (this.b.a5) {
                a.stopPropagation();
            }
        }
        w(a) {
            this.b.ki();
            if (this.b.a5) {
                a.stopPropagation();
            }
        }
        u(a) {
            this.b.kg();
            if (this.b.a5) {
                a.stopPropagation();
            }
        }
        x(a) {
            this.b.kj();
            if (this.b.a5) {
                a.stopPropagation();
            }
        }
        y(a) {
            this.b.ka();
        }
        ab(a) {
            this.b.kd();
        }
        aa(a) {
            this.b.kb();
            if (!this.b.at) {
                a.preventDefault();
            }
            if (this.b.a5) {
                a.stopPropagation();
            }
        }
        ac(a) {
            this.b.ke();
        }
        ad(a) {
            this.b.kf(a.originalEvent.relatedTarget, a.originalEvent.target);
        }
        f() {
            return false;
        }
        z(a) {
        }
        ag() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.k;
            }
        }
        ai() {
            this.e = true;
            this.h.add(this.n.listen("change", runOn(this, this.z)));
            this.h.add(this.n.listen("click", runOn(this, this.aa)));
            this.h.add(this.n.listen("focus", runOn(this, this.ab)));
            this.h.add(this.n.listen("blur", runOn(this, this.y)));
            this.h.add(this.m.listen("click", runOn(this, this.t)));
            this.h.add(this.n.listen("mouseenter", runOn(this, this.v)));
            this.h.add(this.n.listen("mouseleave", runOn(this, this.w)));
            this.h.add(this.n.listen("mousedown", runOn(this, this.u)));
            this.h.add(this.n.listen("mouseup", runOn(this, this.x)));
            this.h.add(this.n.listen("focusin", runOn(this, this.ac)));
            this.h.add(this.n.listen("focusout", runOn(this, this.ad)));
        }
        al() {
            this.e = false;
            for (let a of fromEnum(this.h)) {
                a();
            }
            this.h.clear();
        }
        at() {
            let model_ = this.b;
            if (model_.externalObject && model_.externalObject.refreshDefaults) {
                model_.externalObject.refreshDefaults();
            }
            ;
        }
        ay(a, b) {
            this.c.ax = a;
            this.c.aw = b;
        }
        az(a, b) {
            let c = ElevationHelper.e(a, this.b.n0, this.b.nx, this.b.nn, b);
            this.n.setStyleProperty("box-shadow", c);
        }
        a1(a) {
            if (a != null) {
                this.m.setStyleProperty("font", a.fontString);
            }
        }
        ae(a) {
            this.m.append(a);
        }
        af() {
            this.m.removeChildren();
        }
        r() {
            return this.m.getChildCount() > 0 ? this.m.getChildAt(0) : null;
        }
        a() {
            let rect_ = this.k.rootWrapper.getNativeElement().getBoundingClientRect();
            let a = (rect_.top);
            let b = (rect_.left);
            let c = new Array(2);
            c[0] = a;
            c[1] = b;
            return c;
        }
    }
    ButtonView.$t = /*@__PURE__*/ markType(ButtonView, 'ButtonView');
    return ButtonView;
})();
/**
 * @hidden
 */
export let XButton = /*@__PURE__*/ (() => {
    class XButton extends Base {
        constructor() {
            super();
            this._view = null;
            this.ed = null;
            this.po = XButton.k.ae(XButton.m, "UmbraShadowColor");
            this.pc = XButton.k.ae(XButton.m, "PenumbraShadowColor");
            this.n3 = XButton.k.ae(XButton.m, "AmbientShadowColor");
            this.v = XButton.k.d(XButton.m, "ElevationMode");
            this.pf = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBackgroundColor");
            this.pg = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBorderColor");
            this.ph = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledTextColor");
            this.de = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledElevation");
            this.dh = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "RestingElevation");
            this.dg = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverElevation");
            this.df = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusElevation");
            this.pe = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderColor");
            this.pm = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "RippleColor");
            this.k6 = XButton.k.y(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "CornerRadius");
            this.bt = XButton.k.i(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderWidth");
            this.pd = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "BackgroundColor");
            this.pn = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "TextColor");
            this.pl = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverTextColor");
            this.pk = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverBackgroundColor");
            this.pi = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusBackgroundColor");
            this.pj = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusTextColor");
            this.oh = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledBackgroundColor");
            this.oi = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledBorderColor");
            this.oj = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledTextColor");
            this.c2 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledElevation");
            this.c5 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "RestingElevation");
            this.c4 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverElevation");
            this.c3 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusElevation");
            this.og = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "BorderColor");
            this.oo = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "RippleColor");
            this.k3 = XButton.k.y(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "CornerRadius");
            this.bq = XButton.k.i(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "BorderWidth");
            this.of = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "BackgroundColor");
            this.op = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "TextColor");
            this.on = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverTextColor");
            this.om = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverBackgroundColor");
            this.ok = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusBackgroundColor");
            this.ol = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusTextColor");
            this.o3 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledBackgroundColor");
            this.o4 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledBorderColor");
            this.o5 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledTextColor");
            this.da = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledElevation");
            this.dd = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "RestingElevation");
            this.dc = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverElevation");
            this.db = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusElevation");
            this.o2 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "BorderColor");
            this.pa = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "RippleColor");
            this.k5 = XButton.k.y(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "CornerRadius");
            this.bs = XButton.k.i(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "BorderWidth");
            this.o1 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "BackgroundColor");
            this.pb = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "TextColor");
            this.o9 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverTextColor");
            this.o8 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverBackgroundColor");
            this.o6 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusBackgroundColor");
            this.o7 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusTextColor");
            this.os = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledBackgroundColor");
            this.ot = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledBorderColor");
            this.ou = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledTextColor");
            this.c6 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledElevation");
            this.c9 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "RestingElevation");
            this.c8 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverElevation");
            this.c7 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusElevation");
            this.or = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "BorderColor");
            this.oz = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "RippleColor");
            this.k4 = XButton.k.y(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "CornerRadius");
            this.br = XButton.k.i(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "BorderWidth");
            this.oq = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "BackgroundColor");
            this.o0 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "TextColor");
            this.oy = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverTextColor");
            this.ox = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverBackgroundColor");
            this.ov = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusBackgroundColor");
            this.ow = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusTextColor");
            this.n6 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledBackgroundColor");
            this.n7 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledBorderColor");
            this.n8 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledTextColor");
            this.cy = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledElevation");
            this.c1 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "RestingElevation");
            this.c0 = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverElevation");
            this.cz = XButton.k.n(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusElevation");
            this.n5 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "BorderColor");
            this.od = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "RippleColor");
            this.k2 = XButton.k.y(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "CornerRadius");
            this.bp = XButton.k.i(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "BorderWidth");
            this.n4 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "BackgroundColor");
            this.oe = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "TextColor");
            this.oc = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverTextColor");
            this.ob = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverBackgroundColor");
            this.n9 = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusBackgroundColor");
            this.oa = XButton.k.ad(XButton.m, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusTextColor");
            this.bg = NaN;
            this.bf = NaN;
            this.d = 0;
            this.p = 0;
            this.l = 0;
            this.o = 1;
            this.lh = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderColor");
            this.ls = ThemeResolver.ag(XButton.m, XButton.k, "UmbraShadowColor");
            this.lp = ThemeResolver.ag(XButton.m, XButton.k, "PenumbraShadowColor");
            this.lf = ThemeResolver.ag(XButton.m, XButton.k, "AmbientShadowColor");
            this.b4 = ThemeResolver.p(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "RestingElevation");
            this.b2 = ThemeResolver.p(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusElevation");
            this.b3 = ThemeResolver.p(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverElevation");
            this.lq = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "RippleColor");
            this.ks = ThemeResolver.aa(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "CornerRadius");
            this.lg = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "BackgroundColor");
            this.li = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBackgroundColor");
            this.lj = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBorderColor");
            this.lk = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledTextColor");
            this.b1 = ThemeResolver.p(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledElevation");
            this.s = ThemeResolver.f(XButton.m, XButton.k, "ElevationMode");
            this.lr = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "TextColor");
            this.lo = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverTextColor");
            this.ll = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusBackgroundColor");
            this.lm = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusTextColor");
            this.ln = ThemeResolver.af(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverBackgroundColor");
            this.a6 = ThemeResolver.k(XButton.m, XButton.k, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderWidth");
            this.na = null;
            this.nc = null;
            this.nd = null;
            this.ne = null;
            this.co = -1;
            this.nh = null;
            this.nb = null;
            this.cr = -1;
            this.cq = -1;
            this.cp = -1;
            this.bi = NaN;
            this.ky = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.nj = null;
            this.l8 = null;
            this.ma = null;
            this.mb = null;
            this.mc = null;
            this.ca = -1;
            this.mf = null;
            this.l9 = null;
            this.cd = -1;
            this.cc = -1;
            this.cb = -1;
            this.mh = null;
            this.mi = null;
            this.mg = null;
            this.md = null;
            this.me = null;
            this.bd = NaN;
            this.kv = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.lt = null;
            this.lv = null;
            this.lw = null;
            this.lx = null;
            this.b5 = -1;
            this.t = 0;
            this.ml = null;
            this.lu = null;
            this.cs = -1;
            this.cf = -1;
            this.ce = -1;
            this.z = null;
            this.nm = null;
            this.mn = null;
            this.nl = null;
            this.nk = null;
            this.ni = null;
            this.nf = null;
            this.ng = null;
            this.mj = null;
            this.mk = null;
            this.a7 = NaN;
            this.kt = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.mz = null;
            this.m1 = null;
            this.m2 = null;
            this.m3 = null;
            this.ck = -1;
            this.m6 = null;
            this.m0 = null;
            this.cn = -1;
            this.cm = -1;
            this.cl = -1;
            this.bh = NaN;
            this.kx = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.m8 = null;
            this.m9 = null;
            this.m7 = null;
            this.m4 = null;
            this.m5 = null;
            this.ly = null;
            this.l0 = null;
            this.l1 = null;
            this.l2 = null;
            this.b6 = -1;
            this.mm = null;
            this.lz = null;
            this.b9 = -1;
            this.b8 = -1;
            this.b7 = -1;
            this.bc = NaN;
            this.ku = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.l6 = null;
            this.l7 = null;
            this.l5 = null;
            this.l3 = null;
            this.l4 = null;
            this.mo = null;
            this.mq = null;
            this.mr = null;
            this.ms = null;
            this.cg = -1;
            this.mv = null;
            this.mp = null;
            this.cj = -1;
            this.ci = -1;
            this.ch = -1;
            this.be = NaN;
            this.kw = new CornerRadius(1, NaN, NaN, NaN, NaN);
            this.mx = null;
            this.my = null;
            this.mw = null;
            this.mt = null;
            this.mu = null;
            this.em = "ig-native-button-" + XButton.d9++;
            this.el = "ig-button-" + XButton.d8++;
            this.ei = "inline-block";
            this.eh = null;
            this.ej = "inline-block";
            this.ek = null;
            this.ef = "center";
            this.ea = null;
            this.en = null;
            this.ct = 0;
            this.am = false;
            this.eg = null;
            this.al = false;
            this.ao = false;
            this.ap = true;
            this.aj = false;
            this.af = false;
            this.ah = false;
            this.aq = false;
            this.an = false;
            this.ak = false;
            this.ai = false;
            this.a9 = NaN;
            this.bb = NaN;
            this.ba = NaN;
            this.a8 = NaN;
            this.ld = 1;
            this.rh = 1;
            this.ag = true;
            this.ar = false;
            this.propertyChanged = null;
            this.clicked = null;
            this.mouseEnter = null;
            this.mouseLeave = null;
            this.mouseDown = null;
            this.mouseUp = null;
            this.gotFocus = null;
            this.lostFocus = null;
            let a = new ButtonView();
            a.b = this;
            this.view = a;
            this.view.aq();
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        kk(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.km(a, b, c);
        }
        km(a, b, c) {
            switch (a) {
                case "CornerRadius":
                case "BorderColor":
                case "RestingElevation":
                case "HoverElevation":
                case "FocusElevation":
                case "RippleColor":
                case "BorderWidth":
                case "BackgroundColor":
                case "DisabledBackgroundColor":
                case "DisabledBorderColor":
                case "DisabledTextColor":
                case "DisabledElevation":
                case "HoverBackgroundColor":
                case "FocusTextColor":
                case "TextColor":
                case "HoverTextColor":
                case "FocusBackgroundColor":
                case "RaisedBorderColor":
                case "RaisedRestingElevation":
                case "RaisedFocusElevation":
                case "RaisedHoverElevation":
                case "RaisedRippleColor":
                case "RaisedBorderWidth":
                case "RaisedBackgroundColor":
                case "RaisedDisabledBackgroundColor":
                case "RaisedDisabledBorderColor":
                case "RaisedDisabledTextColor":
                case "RaisedDisabledElevation":
                case "RaisedHoverBackgroundColor":
                case "RaisedCornerRadius":
                case "RaisedFocusBackgroundColor":
                case "RaisedFocusTextColor":
                case "RaisedTextColor":
                case "RaisedHoverTextColor":
                case "FlatBorderColor":
                case "FlatRestingElevation":
                case "FlatFocusElevation":
                case "FlatHoverElevation":
                case "FlatRippleColor":
                case "FlatBorderWidth":
                case "FlatBackgroundColor":
                case "FlatDisabledBackgroundColor":
                case "FlatDisabledBorderColor":
                case "FlatDisabledTextColor":
                case "FlatDisabledElevation":
                case "FlatHoverBackgroundColor":
                case "FlatCornerRadius":
                case "FlatFocusBackgroundColor":
                case "FlatFocusTextColor":
                case "FlatTextColor":
                case "FlatHoverTextColor":
                case "OutlinedRippleColor":
                case "OutlinedRestingElevation":
                case "OutlinedFocusElevation":
                case "OutlinedHoverElevation":
                case "OutlinedBorderColor":
                case "OutlinedBorderWidth":
                case "OutlinedBackgroundColor":
                case "OutlinedDisabledBackgroundColor":
                case "OutlinedDisabledBorderColor":
                case "OutlinedDisabledTextColor":
                case "OutlinedDisabledElevation":
                case "OutlinedHoverBackgroundColor":
                case "OutlinedCornerRadius":
                case "OutlinedFocusBackgroundColor":
                case "OutlinedFocusTextColor":
                case "OutlinedTextColor":
                case "OutlinedHoverTextColor":
                case "FabBorderColor":
                case "FabRippleColor":
                case "FabRestingElevation":
                case "FabFocusElevation":
                case "FabHoverElevation":
                case "FabBorderWidth":
                case "FabBackgroundColor":
                case "FabDisabledBackgroundColor":
                case "FabDisabledBorderColor":
                case "FabDisabledTextColor":
                case "FabDisabledElevation":
                case "FabHoverBackgroundColor":
                case "FabCornerRadius":
                case "FabFocusBackgroundColor":
                case "FabFocusTextColor":
                case "FabTextColor":
                case "FabHoverTextColor":
                case "IconRestingElevation":
                case "IconFocusElevation":
                case "IconHoverElevation":
                case "IconBorderColor":
                case "IconRippleColor":
                case "IconBorderWidth":
                case "IconBackgroundColor":
                case "IconDisabledBackgroundColor":
                case "IconDisabledBorderColor":
                case "IconDisabledTextColor":
                case "IconDisabledElevation":
                case "IconHoverBackgroundColor":
                case "IconCornerRadius":
                case "IconFocusBackgroundColor":
                case "IconFocusTextColor":
                case "IconTextColor":
                case "IconHoverTextColor":
                case "ElevationMode":
                    this.kq();
                    break;
                case "BaseTheme":
                    this.kr(this.n == 0 ? 2 : this.n);
                    this.kq();
                    break;
                case "IsDisabled":
                    this.as = this.disabled || this.aw;
                    this.kq();
                    this.view.as();
                    this.kp();
                    break;
                case "DisableRipple":
                    this.as = this.disabled || this.aw;
                    this.kq();
                    break;
                case "TextStyle":
                case "DisableHover":
                    this.kp();
                    break;
                case "ActualDisableRipple":
                    this.view.am();
                    break;
                case "ActualBackgroundColor":
                case "ActualDisabledBackgroundColor":
                case "ActualDisabledBorderColor":
                case "ActualDisabledTextColor":
                case "ActualDisabledElevation":
                case "ActualHoverBackgroundColor":
                case "ActualBorderColor":
                case "ActualFocusTextColor":
                case "ActualHoverTextColor":
                case "ActualElevationMode":
                    this.kp();
                    break;
                case "Density":
                    this.q = this.r == 0 ? 1 : this.r;
                    break;
                case "ActualDensity":
                case "ActualBorderWidth":
                case "ActualCornerRadius":
                    if (this.e == 4) {
                        this.ko();
                    }
                    this.view.a0();
                    this.kp();
                    break;
                case "DisplayType":
                    this.view.a0();
                    this.kq();
                    this.kp();
                    break;
                case "ContentPaddingLeft":
                case "ContentPaddingTop":
                case "ContentPaddingRight":
                case "ContentPaddingBottom":
                case "FillAvailableSpace":
                    this.view.a0();
                    break;
                case "HorizontalContentAlignment":
                case "VerticalContentAlignment":
                    this.view.au();
                    break;
                case "InputId":
                    this.view.ar();
                    break;
                case "Display":
                    this.view.an();
                    break;
                case "ChildContentDisplay":
                    this.view.aj();
                    break;
                case "FlexDirection":
                    this.view.ao();
                    break;
                case "FlexGrow":
                    this.view.ap();
                    break;
                case "AlignItems":
                    this.view.ah();
                    break;
                case "TabIndex":
                    this.view.ax();
                    break;
                case "DisablePointer":
                    this.view.ax();
                    break;
                case "MinWidth":
                    this.view.aw(this.by);
                    this.view.a0();
                    break;
                case "MinHeight":
                    this.view.av(this.bx);
                    this.view.a0();
                    break;
            }
        }
        k0(a, b) {
            return new CornerRadius(1, !isNaN_(a.d) ? a.d : b.d, !isNaN_(a.e) ? a.e : b.e, !isNaN_(a.c) ? a.c : b.c, !isNaN_(a.b) ? a.b : b.b);
        }
        kq() {
            this.u = this.w != 0 ? this.w : this.v;
            this.n0 = this.po;
            this.nx = this.pc;
            this.nn = this.n3;
            switch (this.e) {
                case 0:
                    this.nq = this.pp != null ? this.pp : this.q6 != null ? this.q6 : this.pf;
                    this.nr = this.pq != null ? this.pq : this.q7 != null ? this.q7 : this.pg;
                    this.ns = this.pr != null ? this.pr : this.q8 != null ? this.q8 : this.ph;
                    this.cu = this.di >= 0 ? this.di : this.d2 >= 0 ? this.d2 : this.de;
                    this.cx = this.d6 >= 0 ? this.d6 : this.d5 >= 0 ? this.d5 : this.dh;
                    this.cw = this.dt >= 0 ? this.dt : this.d4 >= 0 ? this.d4 : this.dg;
                    this.cv = this.ds >= 0 ? this.ds : this.d3 >= 0 ? this.d3 : this.df;
                    this.np = this.n2 != null ? this.n2 : this.q5 != null ? this.q5 : this.pe;
                    this.no = this.n1 != null ? this.n1 : this.q4 != null ? this.q4 : this.pd;
                    this.nv = this.qg != null ? this.qg : this.rb != null ? this.rb : this.pk;
                    this.kz = this.k0(this.k1, this.k0(this.lc, this.k6));
                    this.bj = !isNaN_(this.bk) ? this.bk : !isNaN_(this.b0) ? this.b0 : this.bt;
                    this.ny = this.rf != null ? this.rf : this.rd != null ? this.rd : this.pm;
                    this.nt = this.qe != null ? this.qe : this.q9 != null ? this.q9 : this.pi;
                    this.nu = this.qf != null ? this.qf : this.ra != null ? this.ra : this.pj;
                    this.nz = this.rg != null ? this.rg : this.re != null ? this.re : this.pn;
                    this.nw = this.qh != null ? this.qh : this.rc != null ? this.rc : this.pl;
                    break;
                case 2:
                    this.nq = this.pp != null ? this.pp : this.qv != null ? this.qv : this.o3;
                    this.nr = this.pq != null ? this.pq : this.qw != null ? this.qw : this.o4;
                    this.ns = this.pr != null ? this.pr : this.qx != null ? this.qx : this.o5;
                    this.cu = this.di >= 0 ? this.di : this.dy >= 0 ? this.dy : this.da;
                    this.cx = this.d6 >= 0 ? this.d6 : this.d1 >= 0 ? this.d1 : this.dd;
                    this.cw = this.dt >= 0 ? this.dt : this.d0 >= 0 ? this.d0 : this.dc;
                    this.cv = this.ds >= 0 ? this.ds : this.dz >= 0 ? this.dz : this.db;
                    this.np = this.n2 != null ? this.n2 : this.qu != null ? this.qu : this.o2;
                    this.no = this.qg != null ? this.qg : this.n1 != null ? this.n1 : this.qt != null ? this.qt : this.o1;
                    this.nv = this.q0 != null ? this.q0 : this.o8;
                    this.kz = this.k0(this.k1, this.k0(this.lb, this.k5));
                    this.bj = !isNaN_(this.bk) ? this.bk : !isNaN_(this.bz) ? this.bz : this.bs;
                    this.ny = this.rf != null ? this.rf : this.q2 != null ? this.q2 : this.pa;
                    this.nt = this.qe != null ? this.qe : this.qy != null ? this.qy : this.o6;
                    this.nu = this.qf != null ? this.qf : this.qz != null ? this.qz : this.o7;
                    this.nz = this.rg != null ? this.rg : this.q3 != null ? this.q3 : this.pb;
                    this.nw = this.qh != null ? this.qh : this.q1 != null ? this.q1 : this.o9;
                    break;
                case 1:
                    this.nq = this.pp != null ? this.pp : this.p5 != null ? this.p5 : this.oh;
                    this.nr = this.pq != null ? this.pq : this.p6 != null ? this.p6 : this.oi;
                    this.ns = this.pr != null ? this.pr : this.p7 != null ? this.p7 : this.oj;
                    this.cu = this.di >= 0 ? this.di : this.dn >= 0 ? this.dn : this.c2;
                    this.cx = this.d6 >= 0 ? this.d6 : this.dr >= 0 ? this.dr : this.c5;
                    this.cw = this.dt >= 0 ? this.dt : this.dq >= 0 ? this.dq : this.c4;
                    this.cv = this.ds >= 0 ? this.ds : this.dp >= 0 ? this.dp : this.c3;
                    this.np = this.n2 != null ? this.n2 : this.p4 != null ? this.p4 : this.og;
                    this.no = this.n1 != null ? this.n1 : this.p3 != null ? this.p3 : this.of;
                    this.nv = this.qg != null ? this.qg : this.qa != null ? this.qa : this.om;
                    this.kz = this.k0(this.k1, this.k0(this.k8, this.k3));
                    this.bj = !isNaN_(this.bk) ? this.bk : !isNaN_(this.bv) ? this.bv : this.bq;
                    this.ny = this.rf != null ? this.rf : this.qc != null ? this.qc : this.oo;
                    this.nt = this.qe != null ? this.qe : this.p8 != null ? this.p8 : this.ok;
                    this.nu = this.qf != null ? this.qf : this.p9 != null ? this.p9 : this.ol;
                    this.nz = this.rg != null ? this.rg : this.qd != null ? this.qd : this.op;
                    this.nw = this.qh != null ? this.qh : this.qb != null ? this.qb : this.on;
                    break;
                case 4:
                    this.nq = this.pp != null ? this.pp : this.qk != null ? this.qk : this.os;
                    this.nr = this.pq != null ? this.pq : this.ql != null ? this.ql : this.ot;
                    this.ns = this.pr != null ? this.pr : this.qm != null ? this.qm : this.ou;
                    this.cu = this.di >= 0 ? this.di : this.du >= 0 ? this.du : this.c6;
                    this.cx = this.d6 >= 0 ? this.d6 : this.dx >= 0 ? this.dx : this.c9;
                    this.cw = this.dt >= 0 ? this.dt : this.dw >= 0 ? this.dw : this.c8;
                    this.cv = this.ds >= 0 ? this.ds : this.dv >= 0 ? this.dv : this.c7;
                    this.np = this.n2 != null ? this.n2 : this.qj != null ? this.qj : this.or;
                    this.no = this.n1 != null ? this.n1 : this.qi != null ? this.qi : this.oq;
                    this.nv = this.qg != null ? this.qg : this.qp != null ? this.qp : this.ox;
                    this.ko();
                    this.bj = !isNaN_(this.bk) ? this.bk : !isNaN_(this.bw) ? this.bw : this.br;
                    this.ny = this.rf != null ? this.rf : this.qr != null ? this.qr : this.oz;
                    this.nt = this.qe != null ? this.qe : this.qn != null ? this.qn : this.ov;
                    this.nu = this.qf != null ? this.qf : this.qo != null ? this.qo : this.ow;
                    this.nz = this.rg != null ? this.rg : this.qs != null ? this.qs : this.o0;
                    this.nw = this.qh != null ? this.qh : this.qq != null ? this.qq : this.oy;
                    break;
                case 3:
                    this.nq = this.pp != null ? this.pp : this.pu != null ? this.pu : this.n6;
                    this.nr = this.pq != null ? this.pq : this.pv != null ? this.pv : this.n7;
                    this.ns = this.pr != null ? this.pr : this.pw != null ? this.pw : this.n8;
                    this.cu = this.di >= 0 ? this.di : this.dj >= 0 ? this.dj : this.cy;
                    this.cx = this.d6 >= 0 ? this.d6 : this.dm >= 0 ? this.dm : this.c1;
                    this.cw = this.dt >= 0 ? this.dt : this.dl >= 0 ? this.dl : this.c0;
                    this.cv = this.ds >= 0 ? this.ds : this.dk >= 0 ? this.dk : this.cz;
                    this.np = this.n2 != null ? this.n2 : this.pt != null ? this.pt : this.n5;
                    this.no = this.n1 != null ? this.n1 : this.ps != null ? this.ps : this.n4;
                    this.nv = this.qg != null ? this.qg : this.pz != null ? this.pz : this.ob;
                    this.kz = this.k0(this.k1, this.k0(this.k7, this.k2));
                    this.bj = !isNaN_(this.bk) ? this.bk : !isNaN_(this.bu) ? this.bu : this.bp;
                    this.ny = this.rf != null ? this.rf : this.p1 != null ? this.p1 : this.pm;
                    this.nt = this.qe != null ? this.qe : this.px != null ? this.px : this.n9;
                    this.nu = this.qf != null ? this.qf : this.py != null ? this.py : this.oa;
                    this.nz = this.rg != null ? this.rg : this.p2 != null ? this.p2 : this.oe;
                    this.nw = this.qh != null ? this.qh : this.p0 != null ? this.p0 : this.oc;
                    break;
            }
        }
        ko() {
            this.kz = this.k0(this.k1, this.k0(this.la, this.k9(this.k4)));
        }
        k9(a) {
            switch (this.q) {
                case 1: return a;
                case 2: return a;
                case 3: return a;
                case 4: return new CornerRadius(0, 16);
            }
            return a;
        }
        kb() {
            if (this.disabled) {
                return;
            }
            if (this.clicked != null) {
                this.clicked(this, new ButtonClickEventArgs());
            }
        }
        kg() {
            if (this.disabled) {
                return;
            }
            if (this.mouseDown != null) {
                this.mouseDown(this, new MouseEventArgs());
            }
        }
        kj() {
            if (this.disabled) {
                return;
            }
            if (this.mouseUp != null) {
                this.mouseUp(this, new MouseEventArgs());
            }
        }
        ka() {
            this.focused = false;
            this.kp();
        }
        kd() {
            this.focused = true;
            this.kp();
        }
        ki() {
            this.a3 = false;
            this.kp();
            if (this.mouseLeave != null) {
                this.mouseLeave(this, new MouseEventArgs());
            }
        }
        kh() {
            this.a3 = true;
            this.kp();
            if (this.mouseEnter != null) {
                this.mouseEnter(this, new MouseEventArgs());
            }
        }
        ke() {
            if (this.gotFocus != null) {
                this.gotFocus(this, new FocusEventArgs());
            }
        }
        kf(a, b) {
            if (this.lostFocus != null) {
                this.lostFocus(this, ((() => {
                    let $ret = new FocusEventArgs();
                    $ret.b = a;
                    $ret.a = b;
                    return $ret;
                })()));
            }
        }
        kp() {
            let a = this.view.q;
            if (a == null) {
                return;
            }
            NativeUI.o(a, this.kz);
            NativeUI.n(a, this.np);
            if (!isNaN_(this.bj)) {
                NativeUI.p(a, new Thickness(0, this.bj));
            }
            if (this.disabled) {
                this.view.az(this.cu, this.u);
            }
            else if (this.focused && this.a2) {
                this.view.az(this.cv, this.u);
            }
            else {
                if (this.a3 && !this.au) {
                    this.view.az(this.cw, this.u);
                }
                else {
                    this.view.az(this.cx, this.u);
                }
            }
            if (this.disabled) {
                NativeUI.m(a, this.nq);
            }
            else if (this.focused && this.a2) {
                NativeUI.m(a, this.nt);
            }
            else {
                if (this.a3 && !this.au) {
                    NativeUI.m(a, this.nv);
                }
                else {
                    NativeUI.m(a, this.no);
                }
            }
            this.view.ay(this.ny, BrushUtil.h(0, 0, 0, 0));
            if (this.aa != null) {
                this.view.a1(this.aa);
            }
            if (this.disabled) {
                NativeUI.q(this.view.s, this.ns);
                NativeUI.r(this.view.s, this.ns);
            }
            else if (this.focused && this.a2) {
                NativeUI.q(this.view.s, this.nu);
                NativeUI.r(this.view.s, this.nu);
            }
            else {
                if (this.a3 && !this.au) {
                    NativeUI.q(this.view.s, this.nw);
                    NativeUI.r(this.view.s, this.nw);
                }
                else {
                    NativeUI.q(this.view.s, this.nz);
                    NativeUI.r(this.view.s, this.nz);
                }
            }
        }
        kr(a) {
            this.po = XButton.k.ae(a, "UmbraShadowColor");
            this.pc = XButton.k.ae(a, "PenumbraShadowColor");
            this.n3 = XButton.k.ae(a, "AmbientShadowColor");
            this.v = XButton.k.d(a, "ElevationMode");
            this.pf = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBackgroundColor");
            this.pg = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledBorderColor");
            this.ph = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledTextColor");
            this.de = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 0), "DisabledElevation");
            this.dh = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 0), "RestingElevation");
            this.dg = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverElevation");
            this.df = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusElevation");
            this.pe = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderColor");
            this.pm = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "RippleColor");
            this.k6 = XButton.k.y(a, enumGetBox(ButtonDisplayStyle_$type, 0), "CornerRadius");
            this.bt = XButton.k.i(a, enumGetBox(ButtonDisplayStyle_$type, 0), "BorderWidth");
            this.pd = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "BackgroundColor");
            this.pn = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "TextColor");
            this.pl = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverTextColor");
            this.pk = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "HoverBackgroundColor");
            this.pi = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusBackgroundColor");
            this.pj = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 0), "FocusTextColor");
            this.oh = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledBackgroundColor");
            this.oi = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledBorderColor");
            this.oj = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledTextColor");
            this.c2 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 1), "DisabledElevation");
            this.c5 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 1), "RestingElevation");
            this.c4 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverElevation");
            this.c3 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusElevation");
            this.og = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "BorderColor");
            this.oo = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "RippleColor");
            this.k3 = XButton.k.y(a, enumGetBox(ButtonDisplayStyle_$type, 1), "CornerRadius");
            this.bq = XButton.k.i(a, enumGetBox(ButtonDisplayStyle_$type, 1), "BorderWidth");
            this.of = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "BackgroundColor");
            this.op = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "TextColor");
            this.on = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverTextColor");
            this.om = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "HoverBackgroundColor");
            this.ok = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusBackgroundColor");
            this.ol = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 1), "FocusTextColor");
            this.o3 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledBackgroundColor");
            this.o4 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledBorderColor");
            this.o5 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledTextColor");
            this.da = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 2), "DisabledElevation");
            this.dd = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 2), "RestingElevation");
            this.dc = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverElevation");
            this.db = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusElevation");
            this.o2 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "BorderColor");
            this.pa = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "RippleColor");
            this.k5 = XButton.k.y(a, enumGetBox(ButtonDisplayStyle_$type, 2), "CornerRadius");
            this.bs = XButton.k.i(a, enumGetBox(ButtonDisplayStyle_$type, 2), "BorderWidth");
            this.o1 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "BackgroundColor");
            this.pb = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "TextColor");
            this.o9 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverTextColor");
            this.o8 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "HoverBackgroundColor");
            this.o6 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusBackgroundColor");
            this.o7 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 2), "FocusTextColor");
            this.os = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledBackgroundColor");
            this.ot = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledBorderColor");
            this.ou = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledTextColor");
            this.c6 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 4), "DisabledElevation");
            this.c9 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 4), "RestingElevation");
            this.c8 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverElevation");
            this.c7 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusElevation");
            this.or = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "BorderColor");
            this.oz = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "RippleColor");
            this.k4 = XButton.k.y(a, enumGetBox(ButtonDisplayStyle_$type, 4), "CornerRadius");
            this.br = XButton.k.i(a, enumGetBox(ButtonDisplayStyle_$type, 4), "BorderWidth");
            this.oq = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "BackgroundColor");
            this.o0 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "TextColor");
            this.oy = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverTextColor");
            this.ox = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "HoverBackgroundColor");
            this.ov = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusBackgroundColor");
            this.ow = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 4), "FocusTextColor");
            this.n6 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledBackgroundColor");
            this.n7 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledBorderColor");
            this.n8 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledTextColor");
            this.cy = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 3), "DisabledElevation");
            this.c1 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 3), "RestingElevation");
            this.c0 = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverElevation");
            this.cz = XButton.k.n(a, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusElevation");
            this.n5 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "BorderColor");
            this.od = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "RippleColor");
            this.k2 = XButton.k.y(a, enumGetBox(ButtonDisplayStyle_$type, 3), "CornerRadius");
            this.bp = XButton.k.i(a, enumGetBox(ButtonDisplayStyle_$type, 3), "BorderWidth");
            this.n4 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "BackgroundColor");
            this.oe = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "TextColor");
            this.oc = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverTextColor");
            this.ob = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "HoverBackgroundColor");
            this.n9 = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusBackgroundColor");
            this.oa = XButton.k.ad(a, enumGetBox(ButtonDisplayStyle_$type, 3), "FocusTextColor");
        }
        get by() {
            return this.bg;
        }
        set by(a) {
            let b = this.bg;
            this.bg = a;
            if (b != this.bg) {
                this.kk("MinWidth", b, a);
            }
        }
        get bx() {
            return this.bf;
        }
        set bx(a) {
            let b = this.bf;
            this.bf = a;
            if (b != this.bf) {
                this.kk("MinHeight", b, a);
            }
        }
        get e() {
            return this.d;
        }
        set e(a) {
            let b = this.d;
            this.d = a;
            if (b != this.d) {
                this.kk("DisplayType", enumGetBox(ButtonDisplayStyle_$type, b), enumGetBox(ButtonDisplayStyle_$type, a));
            }
        }
        get r() {
            return this.p;
        }
        set r(a) {
            let b = this.p;
            this.p = a;
            if (b != this.p) {
                this.kk("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get n() {
            return this.l;
        }
        set n(a) {
            let b = this.l;
            this.l = a;
            if (b != this.l) {
                this.kk("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get q() {
            return this.o;
        }
        set q(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.kk("ActualDensity", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, a));
            }
        }
        get np() {
            return this.lh;
        }
        set np(a) {
            let b = this.lh;
            this.lh = a;
            if (b != this.lh) {
                this.kk("ActualBorderColor", b, a);
            }
        }
        get n0() {
            return this.ls;
        }
        set n0(a) {
            let b = this.ls;
            this.ls = a;
            if (b != this.ls) {
                this.kk("ActualUmbraShadowColor", b, a);
            }
        }
        get nx() {
            return this.lp;
        }
        set nx(a) {
            let b = this.lp;
            this.lp = a;
            if (b != this.lp) {
                this.kk("ActualPenumbraShadowColor", b, a);
            }
        }
        get nn() {
            return this.lf;
        }
        set nn(a) {
            let b = this.lf;
            this.lf = a;
            if (b != this.lf) {
                this.kk("ActualAmbientShadowColor", b, a);
            }
        }
        get cx() {
            return this.b4;
        }
        set cx(a) {
            let b = this.b4;
            this.b4 = a;
            if (b != this.b4) {
                this.kk("ActualRestingElevation", b, a);
            }
        }
        get cv() {
            return this.b2;
        }
        set cv(a) {
            let b = this.b2;
            this.b2 = a;
            if (b != this.b2) {
                this.kk("ActualFocusElevation", b, a);
            }
        }
        get cw() {
            return this.b3;
        }
        set cw(a) {
            let b = this.b3;
            this.b3 = a;
            if (b != this.b3) {
                this.kk("ActualHoverElevation", b, a);
            }
        }
        get ny() {
            return this.lq;
        }
        set ny(a) {
            let b = this.lq;
            this.lq = a;
            if (b != this.lq) {
                this.kk("ActualRippleColor", b, a);
            }
        }
        get kz() {
            return this.ks;
        }
        set kz(a) {
            let b = this.ks;
            this.ks = a;
            if (!b.equals(this.ks)) {
                this.kk("ActualCornerRadius", b, a);
            }
        }
        get no() {
            return this.lg;
        }
        set no(a) {
            let b = this.lg;
            this.lg = a;
            if (b != this.lg) {
                this.kk("ActualBackgroundColor", b, a);
            }
        }
        get nq() {
            return this.li;
        }
        set nq(a) {
            let b = this.li;
            this.li = a;
            if (b != this.li) {
                this.kk("ActualDisabledBackgroundColor", b, a);
            }
        }
        get nr() {
            return this.lj;
        }
        set nr(a) {
            let b = this.lj;
            this.lj = a;
            if (b != this.lj) {
                this.kk("ActualDisabledBorderColor", b, a);
            }
        }
        get ns() {
            return this.lk;
        }
        set ns(a) {
            let b = this.lk;
            this.lk = a;
            if (b != this.lk) {
                this.kk("ActualDisabledTextColor", b, a);
            }
        }
        get cu() {
            return this.b1;
        }
        set cu(a) {
            let b = this.b1;
            this.b1 = a;
            if (b != this.b1) {
                this.kk("ActualDisabledElevation", b, a);
            }
        }
        get u() {
            return this.s;
        }
        set u(a) {
            let b = this.s;
            this.s = a;
            if (b != this.s) {
                this.kk("ActualElevationMode", enumGetBox(ElevationMode_$type, b), enumGetBox(ElevationMode_$type, a));
            }
        }
        get nz() {
            return this.lr;
        }
        set nz(a) {
            let b = this.lr;
            this.lr = a;
            if (b != this.lr) {
                this.kk("ActualTextColor", b, a);
            }
        }
        get nw() {
            return this.lo;
        }
        set nw(a) {
            let b = this.lo;
            this.lo = a;
            if (b != this.lo) {
                this.kk("ActualHoverTextColor", b, a);
            }
        }
        get nt() {
            return this.ll;
        }
        set nt(a) {
            let b = this.ll;
            this.ll = a;
            if (b != this.ll) {
                this.kk("ActualFocusBackgroundColor", b, a);
            }
        }
        get nu() {
            return this.lm;
        }
        set nu(a) {
            let b = this.lm;
            this.lm = a;
            if (b != this.lm) {
                this.kk("ActualFocusTextColor", b, a);
            }
        }
        get nv() {
            return this.ln;
        }
        set nv(a) {
            let b = this.ln;
            this.ln = a;
            if (b != this.ln) {
                this.kk("ActualHoverBackgroundColor", b, a);
            }
        }
        get bj() {
            return this.a6;
        }
        set bj(a) {
            let b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.kk("ActualBorderWidth", b, a);
            }
        }
        get q4() {
            return this.na;
        }
        set q4(a) {
            let b = this.na;
            this.na = a;
            if (b != this.na) {
                this.kk("RaisedBackgroundColor", b, a);
            }
        }
        get q6() {
            return this.nc;
        }
        set q6(a) {
            let b = this.nc;
            this.nc = a;
            if (b != this.nc) {
                this.kk("RaisedDisabledBackgroundColor", b, a);
            }
        }
        get q7() {
            return this.nd;
        }
        set q7(a) {
            let b = this.nd;
            this.nd = a;
            if (b != this.nd) {
                this.kk("RaisedDisabledBorderColor", b, a);
            }
        }
        get q8() {
            return this.ne;
        }
        set q8(a) {
            let b = this.ne;
            this.ne = a;
            if (b != this.ne) {
                this.kk("RaisedDisabledTextColor", b, a);
            }
        }
        get d2() {
            return this.co;
        }
        set d2(a) {
            let b = this.co;
            this.co = a;
            if (b != this.co) {
                this.kk("RaisedDisabledElevation", b, a);
            }
        }
        get rb() {
            return this.nh;
        }
        set rb(a) {
            let b = this.nh;
            this.nh = a;
            if (b != this.nh) {
                this.kk("RaisedHoverBackgroundColor", b, a);
            }
        }
        get q5() {
            return this.nb;
        }
        set q5(a) {
            let b = this.nb;
            this.nb = a;
            if (b != this.nb) {
                this.kk("RaisedBorderColor", b, a);
            }
        }
        get d5() {
            return this.cr;
        }
        set d5(a) {
            let b = this.cr;
            this.cr = a;
            if (b != this.cr) {
                this.kk("RaisedRestingElevation", b, a);
            }
        }
        get d4() {
            return this.cq;
        }
        set d4(a) {
            let b = this.cq;
            this.cq = a;
            if (b != this.cq) {
                this.kk("RaisedHoverElevation", b, a);
            }
        }
        get d3() {
            return this.cp;
        }
        set d3(a) {
            let b = this.cp;
            this.cp = a;
            if (b != this.cp) {
                this.kk("RaisedFocusElevation", b, a);
            }
        }
        get b0() {
            return this.bi;
        }
        set b0(a) {
            let b = this.bi;
            this.bi = a;
            if (b != this.bi) {
                this.kk("RaisedBorderWidth", b, a);
            }
        }
        get lc() {
            return this.ky;
        }
        set lc(a) {
            let b = this.ky;
            this.ky = a;
            {
                this.kk("RaisedCornerRadius", b, a);
            }
        }
        get rd() {
            return this.nj;
        }
        set rd(a) {
            let b = this.nj;
            this.nj = a;
            if (b != this.nj) {
                this.kk("RaisedRippleColor", b, a);
            }
        }
        get p3() {
            return this.l8;
        }
        set p3(a) {
            let b = this.l8;
            this.l8 = a;
            if (b != this.l8) {
                this.kk("FlatBackgroundColor", b, a);
            }
        }
        get p5() {
            return this.ma;
        }
        set p5(a) {
            let b = this.ma;
            this.ma = a;
            if (b != this.ma) {
                this.kk("FlatDisabledBackgroundColor", b, a);
            }
        }
        get p6() {
            return this.mb;
        }
        set p6(a) {
            let b = this.mb;
            this.mb = a;
            if (b != this.mb) {
                this.kk("FlatDisabledBorderColor", b, a);
            }
        }
        get p7() {
            return this.mc;
        }
        set p7(a) {
            let b = this.mc;
            this.mc = a;
            if (b != this.mc) {
                this.kk("FlatDisabledTextColor", b, a);
            }
        }
        get dn() {
            return this.ca;
        }
        set dn(a) {
            let b = this.ca;
            this.ca = a;
            if (b != this.ca) {
                this.kk("FlatDisabledElevation", b, a);
            }
        }
        get qa() {
            return this.mf;
        }
        set qa(a) {
            let b = this.mf;
            this.mf = a;
            if (b != this.mf) {
                this.kk("FlatHoverBackgroundColor", b, a);
            }
        }
        get p4() {
            return this.l9;
        }
        set p4(a) {
            let b = this.l9;
            this.l9 = a;
            if (b != this.l9) {
                this.kk("FlatBorderColor", b, a);
            }
        }
        get dr() {
            return this.cd;
        }
        set dr(a) {
            let b = this.cd;
            this.cd = a;
            if (b != this.cd) {
                this.kk("FlatRestingElevation", b, a);
            }
        }
        get dq() {
            return this.cc;
        }
        set dq(a) {
            let b = this.cc;
            this.cc = a;
            if (b != this.cc) {
                this.kk("FlatHoverElevation", b, a);
            }
        }
        get dp() {
            return this.cb;
        }
        set dp(a) {
            let b = this.cb;
            this.cb = a;
            if (b != this.cb) {
                this.kk("FlatFocusElevation", b, a);
            }
        }
        get qc() {
            return this.mh;
        }
        set qc(a) {
            let b = this.mh;
            this.mh = a;
            if (b != this.mh) {
                this.kk("FlatRippleColor", b, a);
            }
        }
        get qd() {
            return this.mi;
        }
        set qd(a) {
            let b = this.mi;
            this.mi = a;
            if (b != this.mi) {
                this.kk("FlatTextColor", b, a);
            }
        }
        get qb() {
            return this.mg;
        }
        set qb(a) {
            let b = this.mg;
            this.mg = a;
            if (b != this.mg) {
                this.kk("FlatHoverTextColor", b, a);
            }
        }
        get p8() {
            return this.md;
        }
        set p8(a) {
            let b = this.md;
            this.md = a;
            if (b != this.md) {
                this.kk("FlatFocusBackgroundColor", b, a);
            }
        }
        get p9() {
            return this.me;
        }
        set p9(a) {
            let b = this.me;
            this.me = a;
            if (b != this.me) {
                this.kk("FlatFocusTextColor", b, a);
            }
        }
        get bv() {
            return this.bd;
        }
        set bv(a) {
            let b = this.bd;
            this.bd = a;
            if (b != this.bd) {
                this.kk("FlatBorderWidth", b, a);
            }
        }
        get k8() {
            return this.kv;
        }
        set k8(a) {
            let b = this.kv;
            this.kv = a;
            {
                this.kk("FlatCornerRadius", b, a);
            }
        }
        get n1() {
            return this.lt;
        }
        set n1(a) {
            let b = this.lt;
            this.lt = a;
            if (b != this.lt) {
                this.kk("BackgroundColor", b, a);
            }
        }
        get pp() {
            return this.lv;
        }
        set pp(a) {
            let b = this.lv;
            this.lv = a;
            if (b != this.lv) {
                this.kk("DisabledBackgroundColor", b, a);
            }
        }
        get pq() {
            return this.lw;
        }
        set pq(a) {
            let b = this.lw;
            this.lw = a;
            if (b != this.lw) {
                this.kk("DisabledBorderColor", b, a);
            }
        }
        get pr() {
            return this.lx;
        }
        set pr(a) {
            let b = this.lx;
            this.lx = a;
            if (b != this.lx) {
                this.kk("DisabledTextColor", b, a);
            }
        }
        get di() {
            return this.b5;
        }
        set di(a) {
            let b = this.b5;
            this.b5 = a;
            if (b != this.b5) {
                this.kk("DisabledElevation", b, a);
            }
        }
        get w() {
            return this.t;
        }
        set w(a) {
            let b = this.t;
            this.t = a;
            if (b != this.t) {
                this.kk("ElevationMode", enumGetBox(ElevationMode_$type, b), enumGetBox(ElevationMode_$type, a));
            }
        }
        get qg() {
            return this.ml;
        }
        set qg(a) {
            let b = this.ml;
            this.ml = a;
            if (b != this.ml) {
                this.kk("HoverBackgroundColor", b, a);
            }
        }
        get n2() {
            return this.lu;
        }
        set n2(a) {
            let b = this.lu;
            this.lu = a;
            if (b != this.lu) {
                this.kk("BorderColor", b, a);
            }
        }
        get d6() {
            return this.cs;
        }
        set d6(a) {
            let b = this.cs;
            this.cs = a;
            if (b != this.cs) {
                this.kk("RestingElevation", b, a);
            }
        }
        get dt() {
            return this.cf;
        }
        set dt(a) {
            let b = this.cf;
            this.cf = a;
            if (b != this.cf) {
                this.kk("HoverElevation", b, a);
            }
        }
        get ds() {
            return this.ce;
        }
        set ds(a) {
            let b = this.ce;
            this.ce = a;
            if (b != this.ce) {
                this.kk("FocusElevation", b, a);
            }
        }
        get aa() {
            return this.z;
        }
        set aa(a) {
            let b = this.z;
            this.z = a;
            if (b != this.z) {
                this.kk("TextStyle", b, a);
            }
        }
        get rg() {
            return this.nm;
        }
        set rg(a) {
            let b = this.nm;
            this.nm = a;
            if (b != this.nm) {
                this.kk("TextColor", b, a);
            }
        }
        get qh() {
            return this.mn;
        }
        set qh(a) {
            let b = this.mn;
            this.mn = a;
            if (b != this.mn) {
                this.kk("HoverTextColor", b, a);
            }
        }
        get rf() {
            return this.nl;
        }
        set rf(a) {
            let b = this.nl;
            this.nl = a;
            if (b != this.nl) {
                this.kk("RippleColor", b, a);
            }
        }
        get re() {
            return this.nk;
        }
        set re(a) {
            let b = this.nk;
            this.nk = a;
            if (b != this.nk) {
                this.kk("RaisedTextColor", b, a);
            }
        }
        get rc() {
            return this.ni;
        }
        set rc(a) {
            let b = this.ni;
            this.ni = a;
            if (b != this.ni) {
                this.kk("RaisedHoverTextColor", b, a);
            }
        }
        get q9() {
            return this.nf;
        }
        set q9(a) {
            let b = this.nf;
            this.nf = a;
            if (b != this.nf) {
                this.kk("RaisedFocusBackgroundColor", b, a);
            }
        }
        get ra() {
            return this.ng;
        }
        set ra(a) {
            let b = this.ng;
            this.ng = a;
            if (b != this.ng) {
                this.kk("RaisedFocusTextColor", b, a);
            }
        }
        get qe() {
            return this.mj;
        }
        set qe(a) {
            let b = this.mj;
            this.mj = a;
            if (b != this.mj) {
                this.kk("FocusBackgroundColor", b, a);
            }
        }
        get qf() {
            return this.mk;
        }
        set qf(a) {
            let b = this.mk;
            this.mk = a;
            if (b != this.mk) {
                this.kk("FocusTextColor", b, a);
            }
        }
        get bk() {
            return this.a7;
        }
        set bk(a) {
            let b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.kk("BorderWidth", b, a);
            }
        }
        get k1() {
            return this.kt;
        }
        set k1(a) {
            let b = this.kt;
            this.kt = a;
            {
                this.kk("CornerRadius", b, a);
            }
        }
        get qt() {
            return this.mz;
        }
        set qt(a) {
            let b = this.mz;
            this.mz = a;
            if (b != this.mz) {
                this.kk("OutlinedBackgroundColor", b, a);
            }
        }
        get qv() {
            return this.m1;
        }
        set qv(a) {
            let b = this.m1;
            this.m1 = a;
            if (b != this.m1) {
                this.kk("OutlinedDisabledBackgroundColor", b, a);
            }
        }
        get qw() {
            return this.m2;
        }
        set qw(a) {
            let b = this.m2;
            this.m2 = a;
            if (b != this.m2) {
                this.kk("OutlinedDisabledBorderColor", b, a);
            }
        }
        get qx() {
            return this.m3;
        }
        set qx(a) {
            let b = this.m3;
            this.m3 = a;
            if (b != this.m3) {
                this.kk("OutlinedDisabledTextColor", b, a);
            }
        }
        get dy() {
            return this.ck;
        }
        set dy(a) {
            let b = this.ck;
            this.ck = a;
            if (b != this.ck) {
                this.kk("OutlinedDisabledElevation", b, a);
            }
        }
        get q0() {
            return this.m6;
        }
        set q0(a) {
            let b = this.m6;
            this.m6 = a;
            if (b != this.m6) {
                this.kk("OutlinedHoverBackgroundColor", b, a);
            }
        }
        get qu() {
            return this.m0;
        }
        set qu(a) {
            let b = this.m0;
            this.m0 = a;
            if (b != this.m0) {
                this.kk("OutlinedBorderColor", b, a);
            }
        }
        get d1() {
            return this.cn;
        }
        set d1(a) {
            let b = this.cn;
            this.cn = a;
            if (b != this.cn) {
                this.kk("OutlinedRestingElevation", b, a);
            }
        }
        get d0() {
            return this.cm;
        }
        set d0(a) {
            let b = this.cm;
            this.cm = a;
            if (b != this.cm) {
                this.kk("OutlinedHoverElevation", b, a);
            }
        }
        get dz() {
            return this.cl;
        }
        set dz(a) {
            let b = this.cl;
            this.cl = a;
            if (b != this.cl) {
                this.kk("OutlinedFocusElevation", b, a);
            }
        }
        get bz() {
            return this.bh;
        }
        set bz(a) {
            let b = this.bh;
            this.bh = a;
            if (b != this.bh) {
                this.kk("OutlinedBorderWidth", b, a);
            }
        }
        get lb() {
            return this.kx;
        }
        set lb(a) {
            let b = this.kx;
            this.kx = a;
            {
                this.kk("OutlinedCornerRadius", b, a);
            }
        }
        get q2() {
            return this.m8;
        }
        set q2(a) {
            let b = this.m8;
            this.m8 = a;
            if (b != this.m8) {
                this.kk("OutlinedRippleColor", b, a);
            }
        }
        get q3() {
            return this.m9;
        }
        set q3(a) {
            let b = this.m9;
            this.m9 = a;
            if (b != this.m9) {
                this.kk("OutlinedTextColor", b, a);
            }
        }
        get q1() {
            return this.m7;
        }
        set q1(a) {
            let b = this.m7;
            this.m7 = a;
            if (b != this.m7) {
                this.kk("OutlinedHoverTextColor", b, a);
            }
        }
        get qy() {
            return this.m4;
        }
        set qy(a) {
            let b = this.m4;
            this.m4 = a;
            if (b != this.m4) {
                this.kk("OutlinedFocusBackgroundColor", b, a);
            }
        }
        get qz() {
            return this.m5;
        }
        set qz(a) {
            let b = this.m5;
            this.m5 = a;
            if (b != this.m5) {
                this.kk("OutlinedFocusTextColor", b, a);
            }
        }
        get ps() {
            return this.ly;
        }
        set ps(a) {
            let b = this.ly;
            this.ly = a;
            if (b != this.ly) {
                this.kk("FabBackgroundColor", b, a);
            }
        }
        get pu() {
            return this.l0;
        }
        set pu(a) {
            let b = this.l0;
            this.l0 = a;
            if (b != this.l0) {
                this.kk("FabDisabledBackgroundColor", b, a);
            }
        }
        get pv() {
            return this.l1;
        }
        set pv(a) {
            let b = this.l1;
            this.l1 = a;
            if (b != this.l1) {
                this.kk("FabDisabledBorderColor", b, a);
            }
        }
        get pw() {
            return this.l2;
        }
        set pw(a) {
            let b = this.l2;
            this.l2 = a;
            if (b != this.l2) {
                this.kk("FabDisabledTextColor", b, a);
            }
        }
        get dj() {
            return this.b6;
        }
        set dj(a) {
            let b = this.b6;
            this.b6 = a;
            if (b != this.b6) {
                this.kk("FabDisabledElevation", b, a);
            }
        }
        get pz() {
            return this.mm;
        }
        set pz(a) {
            let b = this.mm;
            this.mm = a;
            if (b != this.mm) {
                this.kk("FabHoverBackgroundColor", b, a);
            }
        }
        get pt() {
            return this.lz;
        }
        set pt(a) {
            let b = this.lz;
            this.lz = a;
            if (b != this.lz) {
                this.kk("FabBorderColor", b, a);
            }
        }
        get dm() {
            return this.b9;
        }
        set dm(a) {
            let b = this.b9;
            this.b9 = a;
            if (b != this.b9) {
                this.kk("FabRestingElevation", b, a);
            }
        }
        get dl() {
            return this.b8;
        }
        set dl(a) {
            let b = this.b8;
            this.b8 = a;
            if (b != this.b8) {
                this.kk("FabHoverElevation", b, a);
            }
        }
        get dk() {
            return this.b7;
        }
        set dk(a) {
            let b = this.b7;
            this.b7 = a;
            if (b != this.b7) {
                this.kk("FabFocusElevation", b, a);
            }
        }
        get bu() {
            return this.bc;
        }
        set bu(a) {
            let b = this.bc;
            this.bc = a;
            if (b != this.bc) {
                this.kk("FabBorderWidth", b, a);
            }
        }
        get k7() {
            return this.ku;
        }
        set k7(a) {
            let b = this.ku;
            this.ku = a;
            {
                this.kk("FabCornerRadius", b, a);
            }
        }
        get p1() {
            return this.l6;
        }
        set p1(a) {
            let b = this.l6;
            this.l6 = a;
            if (b != this.l6) {
                this.kk("FabRippleColor", b, a);
            }
        }
        get p2() {
            return this.l7;
        }
        set p2(a) {
            let b = this.l7;
            this.l7 = a;
            if (b != this.l7) {
                this.kk("FabTextColor", b, a);
            }
        }
        get p0() {
            return this.l5;
        }
        set p0(a) {
            let b = this.l5;
            this.l5 = a;
            if (b != this.l5) {
                this.kk("FabHoverTextColor", b, a);
            }
        }
        get px() {
            return this.l3;
        }
        set px(a) {
            let b = this.l3;
            this.l3 = a;
            if (b != this.l3) {
                this.kk("FabFocusBackgroundColor", b, a);
            }
        }
        get py() {
            return this.l4;
        }
        set py(a) {
            let b = this.l4;
            this.l4 = a;
            if (b != this.l4) {
                this.kk("FabFocusTextColor", b, a);
            }
        }
        get qi() {
            return this.mo;
        }
        set qi(a) {
            let b = this.mo;
            this.mo = a;
            if (b != this.mo) {
                this.kk("IconBackgroundColor", b, a);
            }
        }
        get qk() {
            return this.mq;
        }
        set qk(a) {
            let b = this.mq;
            this.mq = a;
            if (b != this.mq) {
                this.kk("IconDisabledBackgroundColor", b, a);
            }
        }
        get ql() {
            return this.mr;
        }
        set ql(a) {
            let b = this.mr;
            this.mr = a;
            if (b != this.mr) {
                this.kk("IconDisabledBorderColor", b, a);
            }
        }
        get qm() {
            return this.ms;
        }
        set qm(a) {
            let b = this.ms;
            this.ms = a;
            if (b != this.ms) {
                this.kk("IconDisabledTextColor", b, a);
            }
        }
        get du() {
            return this.cg;
        }
        set du(a) {
            let b = this.cg;
            this.cg = a;
            if (b != this.cg) {
                this.kk("IconDisabledElevation", b, a);
            }
        }
        get qp() {
            return this.mv;
        }
        set qp(a) {
            let b = this.mv;
            this.mv = a;
            if (b != this.mv) {
                this.kk("IconHoverBackgroundColor", b, a);
            }
        }
        get qj() {
            return this.mp;
        }
        set qj(a) {
            let b = this.mp;
            this.mp = a;
            if (b != this.mp) {
                this.kk("IconBorderColor", b, a);
            }
        }
        get dx() {
            return this.cj;
        }
        set dx(a) {
            let b = this.cj;
            this.cj = a;
            if (b != this.cj) {
                this.kk("IconRestingElevation", b, a);
            }
        }
        get dw() {
            return this.ci;
        }
        set dw(a) {
            let b = this.ci;
            this.ci = a;
            if (b != this.ci) {
                this.kk("IconHoverElevation", b, a);
            }
        }
        get dv() {
            return this.ch;
        }
        set dv(a) {
            let b = this.ch;
            this.ch = a;
            if (b != this.ch) {
                this.kk("IconFocusElevation", b, a);
            }
        }
        get bw() {
            return this.be;
        }
        set bw(a) {
            let b = this.be;
            this.be = a;
            if (b != this.be) {
                this.kk("IconBorderWidth", b, a);
            }
        }
        get la() {
            return this.kw;
        }
        set la(a) {
            let b = this.kw;
            this.kw = a;
            {
                this.kk("IconCornerRadius", b, a);
            }
        }
        get qr() {
            return this.mx;
        }
        set qr(a) {
            let b = this.mx;
            this.mx = a;
            if (b != this.mx) {
                this.kk("IconRippleColor", b, a);
            }
        }
        get qs() {
            return this.my;
        }
        set qs(a) {
            let b = this.my;
            this.my = a;
            if (b != this.my) {
                this.kk("IconTextColor", b, a);
            }
        }
        get qq() {
            return this.mw;
        }
        set qq(a) {
            let b = this.mw;
            this.mw = a;
            if (b != this.mw) {
                this.kk("IconHoverTextColor", b, a);
            }
        }
        get qn() {
            return this.mt;
        }
        set qn(a) {
            let b = this.mt;
            this.mt = a;
            if (b != this.mt) {
                this.kk("IconFocusBackgroundColor", b, a);
            }
        }
        get qo() {
            return this.mu;
        }
        set qo(a) {
            let b = this.mu;
            this.mu = a;
            if (b != this.mu) {
                this.kk("IconFocusTextColor", b, a);
            }
        }
        get hy() {
            return this.em;
        }
        set hy(a) {
            let b = this.em;
            this.em = a;
            if (b != this.em) {
                this.kk("InputId", b, a);
            }
        }
        get hw() {
            return this.el;
        }
        set hw(a) {
            let b = this.el;
            this.el = a;
            if (b != this.el) {
                this.kk("Id", b, a);
            }
        }
        get f0() {
            return this.ei;
        }
        set f0(a) {
            let b = this.ei;
            this.ei = a;
            if (b != this.ei) {
                this.kk("Display", b, a);
            }
        }
        get fj() {
            return this.eh;
        }
        set fj(a) {
            let b = this.eh;
            this.eh = a;
            if (b != this.eh) {
                this.kk("ChildContentDisplay", b, this.eh);
            }
        }
        get g4() {
            return this.ej;
        }
        set g4(a) {
            let b = this.ej;
            this.ej = a;
            if (b != this.ej) {
                this.kk("FlexDirection", b, a);
            }
        }
        get g6() {
            return this.ek;
        }
        set g6(a) {
            let b = this.ek;
            this.ek = a;
            if (b != this.ek) {
                this.kk("FlexGrow", b, a);
            }
        }
        get fb() {
            return this.ef;
        }
        set fb(a) {
            let b = this.ef;
            this.ef = a;
            if (b != this.ef) {
                this.kk("AlignItems", b, a);
            }
        }
        get ee() {
            return this.ea;
        }
        set ee(a) {
            let b = this.ea;
            this.ea = a;
            if (b != this.ea) {
                this.kk("Value", b, a);
            }
        }
        get h6() {
            return this.en;
        }
        set h6(a) {
            let b = this.en;
            this.en = a;
            if (b != this.en) {
                this.kk("Name", b, a);
            }
        }
        get az() {
            return this.am;
        }
        get d7() {
            return this.ct;
        }
        set d7(a) {
            let b = this.ct;
            this.ct = a;
            this.am = true;
            if (b != this.ct) {
                this.kk("TabIndex", b, a);
            }
        }
        get fd() {
            return this.eg;
        }
        set fd(a) {
            let b = this.eg;
            this.eg = a;
            if (b != this.eg) {
                this.kk("AriaLabel", b, a);
            }
        }
        get ay() {
            return this.al;
        }
        set ay(a) {
            let b = this.al;
            this.al = a;
            if (b != this.al) {
                this.kk("FillAvailableSpace", b, this.al);
            }
        }
        get focused() {
            return this.ao;
        }
        set focused(a) {
            let b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.kk("IsFocused", b, a);
            }
        }
        get a2() {
            return this.ap;
        }
        set a2(a) {
            let b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.kk("IsFocusStyleEnabled", b, a);
            }
        }
        get aw() {
            return this.aj;
        }
        set aw(a) {
            let b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.kk("DisableRipple", b, a);
            }
        }
        get as() {
            return this.af;
        }
        set as(a) {
            let b = this.af;
            this.af = a;
            if (b != this.af) {
                this.kk("ActualDisableRipple", b, a);
            }
        }
        get au() {
            return this.ah;
        }
        set au(a) {
            let b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.kk("DisableHover", b, this.ah);
            }
        }
        get a3() {
            return this.aq;
        }
        set a3(a) {
            let b = this.aq;
            this.aq = a;
            if (b != this.aq) {
                this.kk("IsHover", b, a);
            }
        }
        get disabled() {
            return this.an;
        }
        set disabled(a) {
            let b = this.an;
            this.an = a;
            if (b != this.an) {
                this.kk("IsDisabled", b, a);
            }
        }
        get ax() {
            return this.ak;
        }
        set ax(a) {
            let b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.kk("DisableTransitions", b, a);
            }
        }
        get av() {
            return this.ai;
        }
        set av(a) {
            let b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.kk("DisablePointer", b, this.ai);
            }
        }
        get bm() {
            return this.a9;
        }
        set bm(a) {
            let b = this.a9;
            this.a9 = a;
            if (b != this.a9) {
                this.kk("ContentPaddingLeft", b, this.a9);
            }
        }
        get bo() {
            return this.bb;
        }
        set bo(a) {
            let b = this.bb;
            this.bb = a;
            if (b != this.bb) {
                this.kk("ContentPaddingTop", b, this.bb);
            }
        }
        get bn() {
            return this.ba;
        }
        set bn(a) {
            let b = this.ba;
            this.ba = a;
            if (b != this.ba) {
                this.kk("ContentPaddingRight", b, this.ba);
            }
        }
        get bl() {
            return this.a8;
        }
        set bl(a) {
            let b = this.a8;
            this.a8 = a;
            if (b != this.a8) {
                this.kk("ContentPaddingBottom", b, this.a8);
            }
        }
        get le() {
            return this.ld;
        }
        set le(a) {
            let b = this.ld;
            this.ld = a;
            if (b != this.ld) {
                this.kk("HorizontalContentAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.ld));
            }
        }
        get ri() {
            return this.rh;
        }
        set ri(a) {
            let b = this.rh;
            this.rh = a;
            if (b != this.rh) {
                this.kk("VerticalContentAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.rh));
            }
        }
        get at() {
            return this.ag;
        }
        set at(a) {
            let b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.kk("ClickTunneling", b, this.ag);
            }
        }
        get a5() {
            return this.ar;
        }
        set a5(a) {
            let b = this.ar;
            this.ar = a;
            if (b != this.ar) {
                this.kk("StopPropagation", b, this.ar);
            }
        }
        kl() {
            this.j8();
            this.view.ay(this.ny, BrushUtil.h(0, 0, 0, 0));
            this.kp();
        }
        get a() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 0;
            return a;
        }
        j8() {
            this.view.ag();
        }
        onDetachedFromUI() {
            this.view.al();
        }
        onAttachedToUI() {
            this.view.ai();
        }
        appendButtonContent(a) {
            this.view.ae(a);
        }
        clearButtonContent() {
            this.view.af();
        }
        getButtonContent() {
            return this.view.r();
        }
        a4() {
            return this.view.g();
        }
        eb() {
            return this.b();
        }
        f4() {
            let a = this.b();
            return a.serialize();
        }
        b() {
            let a = this.view.q;
            let b = this.view.s;
            let c = new ButtonVisualModelExport();
            let d = this.view.a();
            c.s = d[0];
            c.q = d[1];
            c.p = NativeUI.d(a);
            c.t = NativeUI.k(a);
            c.h = this.n;
            c.i = this.q;
            c.c = AppearanceHelper.a(NativeUI.ak(a));
            c.g = AppearanceHelper.a(this.n0);
            c.d = AppearanceHelper.a(this.nx);
            c.a = AppearanceHelper.a(this.nn);
            c.u = this.cx;
            c.e = AppearanceHelper.a(this.ny);
            c.ag = this.kz;
            c.b = AppearanceHelper.a(NativeUI.aj(a));
            c.j = this.u;
            c.f = AppearanceHelper.a(NativeUI.al(b));
            c.o = this.bj;
            c.x = this.f0;
            c.y = this.g4;
            c.z = this.g6;
            c.w = this.fb;
            c.v = this.view.s.getNativeElement().innerText;
            c.aa = this.h6;
            c.m = this.focused;
            c.k = this.as;
            c.n = this.a3;
            c.l = this.disabled;
            if (this.aa != null) {
                let e = this.aa;
                if (this.view != null && e.q == null) {
                    let f = this.view.k;
                    let g = FontUtil.getFontInfoFromString(f, e.fontString);
                    e.q = g.q;
                    e.f = g.f;
                    e.r = g.r;
                    e.t = g.t;
                    e.u = g.u;
                    e.v = g.v;
                }
                if (e.q != null) {
                    c.ab = e.q;
                }
                if (!isNaN_(e.f)) {
                    c.r = e.f;
                }
                if (e.v != null) {
                    c.af = e.v;
                }
                if (e.t != null) {
                    c.ad = e.t;
                }
                if (e.r != null) {
                    c.ac = e.t;
                }
            }
            return c;
        }
        provideContainer(a) {
            this.view.ak(a);
        }
    }
    XButton.$t = /*@__PURE__*/ markType(XButton, 'XButton', Base.$, [INotifyPropertyChanged_$type]);
    XButton.m = 2;
    XButton.d9 = 0;
    XButton.d8 = 0;
    XButton.i = /*@__PURE__*/ new Theme(1, /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(String_$type, Base.$, 0);
        $ret.addItem("UmbraShadowColor", BrushUtil.h(66, 0, 0, 0));
        $ret.addItem("PenumbraShadowColor", BrushUtil.h(30, 0, 0, 0));
        $ret.addItem("AmbientShadowColor", BrushUtil.h(20, 0, 0, 0));
        $ret.addItem("ElevationMode", enumGetBox(ElevationMode_$type, 1));
        return $ret;
    })()), /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(Base.$, Theme.$, 0);
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 0), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 2);
            $ret.addItem("HoverElevation", 4);
            $ret.addItem("FocusElevation", 8);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 4));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("TextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 220, 83, 145));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 220, 83, 145));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 1), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 0);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 4));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(13, 228, 28, 119));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(30, 228, 28, 119));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 228, 28, 119));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 2), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(30, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 0);
            $ret.addItem("BorderColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("RippleColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 4));
            $ret.addItem("BorderWidth", 1);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(13, 228, 28, 119));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(30, 228, 28, 119));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 228, 28, 119));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 4), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 0);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(30, 0, 0, 0));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 3), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 6);
            $ret.addItem("HoverElevation", 12);
            $ret.addItem("FocusElevation", 12);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 228, 28, 119));
            $ret.addItem("TextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 220, 83, 145));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 220, 83, 145));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 0, 0, 0));
            return $ret;
        })())));
        return $ret;
    })()));
    XButton.h = /*@__PURE__*/ new Theme(1, /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(String_$type, Base.$, 0);
        $ret.addItem("UmbraShadowColor", BrushUtil.h(100, 33, 150, 243));
        $ret.addItem("PenumbraShadowColor", BrushUtil.h(70, 33, 150, 243));
        $ret.addItem("AmbientShadowColor", BrushUtil.h(40, 33, 150, 243));
        $ret.addItem("ElevationMode", enumGetBox(ElevationMode_$type, 2));
        return $ret;
    })()), /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(Base.$, Theme.$, 0);
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 0), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("TextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 27, 135, 220));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 21, 112, 184));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 1), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(100, 33, 150, 243));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(26, 33, 150, 243));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 33, 150, 243));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 2), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(30, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("RippleColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", 1);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(26, 33, 150, 243));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 4), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", null);
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(30, 0, 0, 0));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 33, 150, 243));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 3), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("TextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 27, 135, 220));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 21, 112, 184));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        return $ret;
    })()));
    XButton.j = /*@__PURE__*/ new Theme(1, /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(String_$type, Base.$, 0);
        $ret.addItem("UmbraShadowColor", BrushUtil.h(100, 33, 150, 243));
        $ret.addItem("PenumbraShadowColor", BrushUtil.h(70, 33, 150, 243));
        $ret.addItem("AmbientShadowColor", BrushUtil.h(40, 33, 150, 243));
        $ret.addItem("ElevationMode", enumGetBox(ElevationMode_$type, 2));
        return $ret;
    })()), /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(Base.$, Theme.$, 0);
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 0), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("TextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 27, 135, 220));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 21, 112, 184));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 1), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(100, 33, 150, 243));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 119, 119, 119));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(26, 33, 150, 243));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 33, 150, 243));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 2), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(30, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("RippleColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("CornerRadius", new CornerRadius(0, 3));
            $ret.addItem("BorderWidth", 1);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(26, 33, 150, 243));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 4), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", null);
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(0, 0, 0, 0));
            $ret.addItem("TextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 0, 0, 0));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(51, 178, 191, 220));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(51, 178, 191, 220));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 0, 0, 0));
            return $ret;
        })())));
        $ret.addItem(enumGetBox(ButtonDisplayStyle_$type, 3), new Theme(0, ((() => {
            let $ret = new Dictionary$2(String_$type, Base.$, 0);
            $ret.addItem("DisabledBackgroundColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledBorderColor", BrushUtil.h(10, 0, 0, 0));
            $ret.addItem("DisabledTextColor", BrushUtil.h(66, 0, 0, 0));
            $ret.addItem("DisabledElevation", 0);
            $ret.addItem("RestingElevation", 0);
            $ret.addItem("HoverElevation", 0);
            $ret.addItem("FocusElevation", 2);
            $ret.addItem("BorderColor", BrushUtil.h(138, 0, 0, 0));
            $ret.addItem("RippleColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("CornerRadius", new CornerRadius(0, 28));
            $ret.addItem("BorderWidth", NaN);
            $ret.addItem("BackgroundColor", BrushUtil.h(255, 33, 150, 243));
            $ret.addItem("TextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverTextColor", BrushUtil.h(255, 255, 255, 255));
            $ret.addItem("HoverBackgroundColor", BrushUtil.h(255, 27, 135, 220));
            $ret.addItem("FocusBackgroundColor", BrushUtil.h(255, 21, 112, 184));
            $ret.addItem("FocusTextColor", BrushUtil.h(255, 255, 255, 255));
            return $ret;
        })())));
        return $ret;
    })()));
    XButton.k = /*@__PURE__*/ new ThemeResolver(1, /*@__PURE__*/ ((() => {
        let $ret = new Dictionary$2(BaseControlTheme_$type, Theme.$, 0);
        $ret.addItem(2, XButton.i);
        $ret.addItem(1, XButton.h);
        $ret.addItem(3, XButton.j);
        return $ret;
    })()), 2);
    return XButton;
})();
