import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { HorizontalAlignment } from "igniteui-react-core";
import { ElevationMode } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { ButtonDisplayStyle } from "./ButtonDisplayStyle";
import { BaseControlTheme } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { VerticalAlignment } from "igniteui-react-core";
import { ThemeResolver } from "./ThemeResolver";
import { ButtonClickEventArgs } from "./ButtonClickEventArgs";
import { MouseEventArgs } from "igniteui-react-core";
import { FocusEventArgs } from "igniteui-react-core";
import { ButtonVisualModelExport } from "./ButtonVisualModelExport";
import { Theme } from "./Theme";
/**
 * @hidden
 */
export declare class ButtonView extends Base {
    static $t: Type;
    constructor();
    b: XButton;
    aq(): void;
    g(): boolean;
    k: DomRenderer;
    private d;
    private h;
    get q(): any;
    get s(): any;
    ak(a: DomRenderer): void;
    am(): void;
    a0(): void;
    au(): void;
    aw(a: number): void;
    av(a: number): void;
    as(): void;
    an(): void;
    aj(): void;
    ah(): void;
    ao(): void;
    ap(): void;
    private t;
    ax(): void;
    ar(): void;
    private v;
    private w;
    private u;
    private x;
    private y;
    private ab;
    private aa;
    private ac;
    private ad;
    private f;
    private z;
    ag(): void;
    private e;
    private n;
    private j;
    private i;
    private l;
    private c;
    private m;
    private p;
    private o;
    ai(): void;
    al(): void;
    at(): void;
    ay(a: Brush, b: Brush): void;
    az(a: number, b: ElevationMode): void;
    a1(a: FontInfo): void;
    ae(a: any): void;
    af(): void;
    r(): any;
    a(): number[];
}
/**
 * @hidden
 */
export declare class XButton extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private _view;
    get view(): ButtonView;
    set view(a: ButtonView);
    ed: any;
    destroy(): void;
    protected kk(a: string, b: any, c: any): void;
    protected km(a: string, b: any, c: any): void;
    private k0;
    private kq;
    private ko;
    private k9;
    kb(): void;
    kg(): void;
    kj(): void;
    ka(): void;
    kd(): void;
    ki(): void;
    kh(): void;
    ke(): void;
    kf(a: any, b: any): void;
    private kp;
    static m: BaseControlTheme;
    po: Brush;
    pc: Brush;
    n3: Brush;
    v: ElevationMode;
    pf: Brush;
    pg: Brush;
    ph: Brush;
    de: number;
    dh: number;
    dg: number;
    df: number;
    pe: Brush;
    pm: Brush;
    k6: CornerRadius;
    bt: number;
    pd: Brush;
    pn: Brush;
    pl: Brush;
    pk: Brush;
    pi: Brush;
    pj: Brush;
    oh: Brush;
    oi: Brush;
    oj: Brush;
    c2: number;
    c5: number;
    c4: number;
    c3: number;
    og: Brush;
    oo: Brush;
    k3: CornerRadius;
    bq: number;
    of: Brush;
    op: Brush;
    on: Brush;
    om: Brush;
    ok: Brush;
    ol: Brush;
    o3: Brush;
    o4: Brush;
    o5: Brush;
    da: number;
    dd: number;
    dc: number;
    db: number;
    o2: Brush;
    pa: Brush;
    k5: CornerRadius;
    bs: number;
    o1: Brush;
    pb: Brush;
    o9: Brush;
    o8: Brush;
    o6: Brush;
    o7: Brush;
    os: Brush;
    ot: Brush;
    ou: Brush;
    c6: number;
    c9: number;
    c8: number;
    c7: number;
    or: Brush;
    oz: Brush;
    k4: CornerRadius;
    br: number;
    oq: Brush;
    o0: Brush;
    oy: Brush;
    ox: Brush;
    ov: Brush;
    ow: Brush;
    n6: Brush;
    n7: Brush;
    n8: Brush;
    cy: number;
    c1: number;
    c0: number;
    cz: number;
    n5: Brush;
    od: Brush;
    k2: CornerRadius;
    bp: number;
    n4: Brush;
    oe: Brush;
    oc: Brush;
    ob: Brush;
    n9: Brush;
    oa: Brush;
    private kr;
    private bg;
    get by(): number;
    set by(a: number);
    private bf;
    get bx(): number;
    set bx(a: number);
    private d;
    get e(): ButtonDisplayStyle;
    set e(a: ButtonDisplayStyle);
    private p;
    get r(): ControlDisplayDensity;
    set r(a: ControlDisplayDensity);
    private l;
    get n(): BaseControlTheme;
    set n(a: BaseControlTheme);
    private o;
    get q(): ControlDisplayDensity;
    set q(a: ControlDisplayDensity);
    private lh;
    get np(): Brush;
    set np(a: Brush);
    private ls;
    get n0(): Brush;
    set n0(a: Brush);
    private lp;
    get nx(): Brush;
    set nx(a: Brush);
    private lf;
    get nn(): Brush;
    set nn(a: Brush);
    private b4;
    get cx(): number;
    set cx(a: number);
    private b2;
    get cv(): number;
    set cv(a: number);
    private b3;
    get cw(): number;
    set cw(a: number);
    private lq;
    get ny(): Brush;
    set ny(a: Brush);
    private ks;
    get kz(): CornerRadius;
    set kz(a: CornerRadius);
    private lg;
    get no(): Brush;
    set no(a: Brush);
    private li;
    get nq(): Brush;
    set nq(a: Brush);
    private lj;
    get nr(): Brush;
    set nr(a: Brush);
    private lk;
    get ns(): Brush;
    set ns(a: Brush);
    private b1;
    get cu(): number;
    set cu(a: number);
    private s;
    get u(): ElevationMode;
    set u(a: ElevationMode);
    private lr;
    get nz(): Brush;
    set nz(a: Brush);
    private lo;
    get nw(): Brush;
    set nw(a: Brush);
    private ll;
    get nt(): Brush;
    set nt(a: Brush);
    private lm;
    get nu(): Brush;
    set nu(a: Brush);
    private ln;
    get nv(): Brush;
    set nv(a: Brush);
    private a6;
    get bj(): number;
    set bj(a: number);
    private na;
    get q4(): Brush;
    set q4(a: Brush);
    private nc;
    get q6(): Brush;
    set q6(a: Brush);
    private nd;
    get q7(): Brush;
    set q7(a: Brush);
    private ne;
    get q8(): Brush;
    set q8(a: Brush);
    private co;
    get d2(): number;
    set d2(a: number);
    private nh;
    get rb(): Brush;
    set rb(a: Brush);
    private nb;
    get q5(): Brush;
    set q5(a: Brush);
    private cr;
    get d5(): number;
    set d5(a: number);
    private cq;
    get d4(): number;
    set d4(a: number);
    private cp;
    get d3(): number;
    set d3(a: number);
    private bi;
    get b0(): number;
    set b0(a: number);
    private ky;
    get lc(): CornerRadius;
    set lc(a: CornerRadius);
    private nj;
    get rd(): Brush;
    set rd(a: Brush);
    private l8;
    get p3(): Brush;
    set p3(a: Brush);
    private ma;
    get p5(): Brush;
    set p5(a: Brush);
    private mb;
    get p6(): Brush;
    set p6(a: Brush);
    private mc;
    get p7(): Brush;
    set p7(a: Brush);
    private ca;
    get dn(): number;
    set dn(a: number);
    private mf;
    get qa(): Brush;
    set qa(a: Brush);
    private l9;
    get p4(): Brush;
    set p4(a: Brush);
    private cd;
    get dr(): number;
    set dr(a: number);
    private cc;
    get dq(): number;
    set dq(a: number);
    private cb;
    get dp(): number;
    set dp(a: number);
    private mh;
    get qc(): Brush;
    set qc(a: Brush);
    private mi;
    get qd(): Brush;
    set qd(a: Brush);
    private mg;
    get qb(): Brush;
    set qb(a: Brush);
    private md;
    get p8(): Brush;
    set p8(a: Brush);
    private me;
    get p9(): Brush;
    set p9(a: Brush);
    private bd;
    get bv(): number;
    set bv(a: number);
    private kv;
    get k8(): CornerRadius;
    set k8(a: CornerRadius);
    private lt;
    get n1(): Brush;
    set n1(a: Brush);
    private lv;
    get pp(): Brush;
    set pp(a: Brush);
    private lw;
    get pq(): Brush;
    set pq(a: Brush);
    private lx;
    get pr(): Brush;
    set pr(a: Brush);
    private b5;
    get di(): number;
    set di(a: number);
    private t;
    get w(): ElevationMode;
    set w(a: ElevationMode);
    private ml;
    get qg(): Brush;
    set qg(a: Brush);
    private lu;
    get n2(): Brush;
    set n2(a: Brush);
    private cs;
    get d6(): number;
    set d6(a: number);
    private cf;
    get dt(): number;
    set dt(a: number);
    private ce;
    get ds(): number;
    set ds(a: number);
    private z;
    get aa(): FontInfo;
    set aa(a: FontInfo);
    private nm;
    get rg(): Brush;
    set rg(a: Brush);
    private mn;
    get qh(): Brush;
    set qh(a: Brush);
    private nl;
    get rf(): Brush;
    set rf(a: Brush);
    private nk;
    get re(): Brush;
    set re(a: Brush);
    private ni;
    get rc(): Brush;
    set rc(a: Brush);
    private nf;
    get q9(): Brush;
    set q9(a: Brush);
    private ng;
    get ra(): Brush;
    set ra(a: Brush);
    private mj;
    get qe(): Brush;
    set qe(a: Brush);
    private mk;
    get qf(): Brush;
    set qf(a: Brush);
    private a7;
    get bk(): number;
    set bk(a: number);
    private kt;
    get k1(): CornerRadius;
    set k1(a: CornerRadius);
    private mz;
    get qt(): Brush;
    set qt(a: Brush);
    private m1;
    get qv(): Brush;
    set qv(a: Brush);
    private m2;
    get qw(): Brush;
    set qw(a: Brush);
    private m3;
    get qx(): Brush;
    set qx(a: Brush);
    private ck;
    get dy(): number;
    set dy(a: number);
    private m6;
    get q0(): Brush;
    set q0(a: Brush);
    private m0;
    get qu(): Brush;
    set qu(a: Brush);
    private cn;
    get d1(): number;
    set d1(a: number);
    private cm;
    get d0(): number;
    set d0(a: number);
    private cl;
    get dz(): number;
    set dz(a: number);
    private bh;
    get bz(): number;
    set bz(a: number);
    private kx;
    get lb(): CornerRadius;
    set lb(a: CornerRadius);
    private m8;
    get q2(): Brush;
    set q2(a: Brush);
    private m9;
    get q3(): Brush;
    set q3(a: Brush);
    private m7;
    get q1(): Brush;
    set q1(a: Brush);
    private m4;
    get qy(): Brush;
    set qy(a: Brush);
    private m5;
    get qz(): Brush;
    set qz(a: Brush);
    private ly;
    get ps(): Brush;
    set ps(a: Brush);
    private l0;
    get pu(): Brush;
    set pu(a: Brush);
    private l1;
    get pv(): Brush;
    set pv(a: Brush);
    private l2;
    get pw(): Brush;
    set pw(a: Brush);
    private b6;
    get dj(): number;
    set dj(a: number);
    private mm;
    get pz(): Brush;
    set pz(a: Brush);
    private lz;
    get pt(): Brush;
    set pt(a: Brush);
    private b9;
    get dm(): number;
    set dm(a: number);
    private b8;
    get dl(): number;
    set dl(a: number);
    private b7;
    get dk(): number;
    set dk(a: number);
    private bc;
    get bu(): number;
    set bu(a: number);
    private ku;
    get k7(): CornerRadius;
    set k7(a: CornerRadius);
    private l6;
    get p1(): Brush;
    set p1(a: Brush);
    private l7;
    get p2(): Brush;
    set p2(a: Brush);
    private l5;
    get p0(): Brush;
    set p0(a: Brush);
    private l3;
    get px(): Brush;
    set px(a: Brush);
    private l4;
    get py(): Brush;
    set py(a: Brush);
    private mo;
    get qi(): Brush;
    set qi(a: Brush);
    private mq;
    get qk(): Brush;
    set qk(a: Brush);
    private mr;
    get ql(): Brush;
    set ql(a: Brush);
    private ms;
    get qm(): Brush;
    set qm(a: Brush);
    private cg;
    get du(): number;
    set du(a: number);
    private mv;
    get qp(): Brush;
    set qp(a: Brush);
    private mp;
    get qj(): Brush;
    set qj(a: Brush);
    private cj;
    get dx(): number;
    set dx(a: number);
    private ci;
    get dw(): number;
    set dw(a: number);
    private ch;
    get dv(): number;
    set dv(a: number);
    private be;
    get bw(): number;
    set bw(a: number);
    private kw;
    get la(): CornerRadius;
    set la(a: CornerRadius);
    private mx;
    get qr(): Brush;
    set qr(a: Brush);
    private my;
    get qs(): Brush;
    set qs(a: Brush);
    private mw;
    get qq(): Brush;
    set qq(a: Brush);
    private mt;
    get qn(): Brush;
    set qn(a: Brush);
    private mu;
    get qo(): Brush;
    set qo(a: Brush);
    private static d9;
    private em;
    get hy(): string;
    set hy(a: string);
    private static d8;
    private el;
    get hw(): string;
    set hw(a: string);
    private ei;
    get f0(): string;
    set f0(a: string);
    private eh;
    get fj(): string;
    set fj(a: string);
    private ej;
    get g4(): string;
    set g4(a: string);
    private ek;
    get g6(): string;
    set g6(a: string);
    private ef;
    get fb(): string;
    set fb(a: string);
    private ea;
    get ee(): any;
    set ee(a: any);
    private en;
    get h6(): string;
    set h6(a: string);
    private ct;
    private am;
    get az(): boolean;
    get d7(): number;
    set d7(a: number);
    private eg;
    get fd(): string;
    set fd(a: string);
    private al;
    get ay(): boolean;
    set ay(a: boolean);
    private ao;
    get focused(): boolean;
    set focused(a: boolean);
    private ap;
    get a2(): boolean;
    set a2(a: boolean);
    private aj;
    get aw(): boolean;
    set aw(a: boolean);
    private af;
    get as(): boolean;
    set as(a: boolean);
    private ah;
    get au(): boolean;
    set au(a: boolean);
    private aq;
    get a3(): boolean;
    set a3(a: boolean);
    private an;
    get disabled(): boolean;
    set disabled(a: boolean);
    private ak;
    get ax(): boolean;
    set ax(a: boolean);
    private ai;
    get av(): boolean;
    set av(a: boolean);
    private a9;
    get bm(): number;
    set bm(a: number);
    private bb;
    get bo(): number;
    set bo(a: number);
    private ba;
    get bn(): number;
    set bn(a: number);
    private a8;
    get bl(): number;
    set bl(a: number);
    private ld;
    get le(): HorizontalAlignment;
    set le(a: HorizontalAlignment);
    private rh;
    get ri(): VerticalAlignment;
    set ri(a: VerticalAlignment);
    private ag;
    get at(): boolean;
    set at(a: boolean);
    private ar;
    get a5(): boolean;
    set a5(a: boolean);
    kl(): void;
    private get a();
    private j8;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    appendButtonContent(a: any): void;
    clearButtonContent(): void;
    getButtonContent(): any;
    protected a4(): boolean;
    eb(): any;
    f4(): string;
    b(): ButtonVisualModelExport;
    provideContainer(a: DomRenderer): void;
    clicked: (sender: any, args: ButtonClickEventArgs) => void;
    mouseEnter: (sender: any, args: MouseEventArgs) => void;
    mouseLeave: (sender: any, args: MouseEventArgs) => void;
    mouseDown: (sender: any, args: MouseEventArgs) => void;
    mouseUp: (sender: any, args: MouseEventArgs) => void;
    gotFocus: (sender: any, args: FocusEventArgs) => void;
    lostFocus: (sender: any, args: FocusEventArgs) => void;
    static i: Theme;
    static h: Theme;
    static j: Theme;
    static k: ThemeResolver;
}
